/******************** (C) COPYRIGHT 2014 e-Design Co.,Ltd. *********************
 File Name : Menu.c
 Version   : DS202 Ver 1.0                                   Author : bure
*******************************************************************************/
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include "Version.h"
#include "Process.h"
#include "Menu.h"
#include "Draw.h"
#include "LCD.h"
#include "BIOS.h"
#include "Func.h"
#include "Drive.h"
#include "File.h"
#include "math.h"

#define Menu_X    263        
#define Menu_Y    183
#define ITEM_X    Menu_X
#define ITEM_Y    Menu_Y-1
#define TITLE_H   223
#define TITLE_L   3
#define RowHeight 14
#define MAX_FREQ  10                             /*ģⲨƵΪ20KHz*/
typedef  uint64_t     u64;
typedef  int64_t      s64;

static void MeasureStr(u8 Source, u8 Item);

uc8  XSTR[][6] = {"uS", "mS", "S "};
uc8  YSTR[][6] = {"uV", "mV", "V "};
uc8  FSTR[][6] = {"Hz", "Hz", "KHz", "MHz"};
uc8  PCNT[]    =  "%";
uc8  NSTR[][6] = {"  ", "  ", "  "};

//==============+======+======+======+======+======+======+======+======+======+
//  ״̬    |  | ȫ |  |  | ȫ |  |  |             |
//--------------+------+------+------+------+------+------+------+------+------+
uc8  BT_S[][5] ={ ";<=", ";<=", ";&@", ";*@", ">`@", "\"#$", "\"#$"};// Ŵ |
uc16 V_BT[]    ={  3000,  3400,  3700,  3850,  4200,  4200,  4200};  // ѹֵ |
uc16 BT_C[]    ={  RED,   YEL,   GRN,   GRN,   GRN,   CYN,   GRN };  // ɫ   |
//==============+======+======+======+======+======+======+======+======+======+

uc16 SIN_DATA[36] =  // Sine wave data                                 
  {0x000,0x027,0x08E,0x130,0x209,0x311,0x441,0x58F,0x6F0,    // 90
   0x85A,0x9C0,0xB19,0xC59,0xD76,0xE68,0xF26,0xFAB,0xFF3,    // 180
   0xFFF,0xFD7,0xF70,0xECE,0xDF5,0xCED,0xBBD,0xA6F,0x90E,    // 270
   0x7A4,0x63E,0x4E5,0x3A5,0x288,0x196,0x0D8,0x053,0x00B,};  // 360

uc16 TRG_DATA[36] =  // triangle wave data
  {0x000,0x0E3,0x1C6,0x2AA,0x38D,0x471,0x554,0x638,0x71B,    // 90
   0x7FF,0x8E2,0x9C6,0xAA9,0xB8D,0xC70,0xD54,0xE37,0xF1B,    // 180
   0xFFE,0xF1B,0xE37,0xD54,0xC70,0xB8D,0xAA9,0x9C6,0x8E2,    // 270
   0x7FF,0x71B,0x638,0x554,0x471,0x38D,0x2AA,0x1C6,0x0E3};   // 360

uc16 SAW_DATA[36] =  // Sawtooth wave data                            
  {0x000,0x075,0x0EA,0x15F,0x1D4,0x249,0x2BE,0x333,0x3A8,    // 90
   0x41D,0x492,0x507,0x57C,0x5F1,0x666,0x6DB,0x750,0x7C5,    // 180
   0x83A,0x8AF,0x924,0x999,0xA0E,0xA83,0xAF8,0xB6D,0xBE2,    // 270
   0xC57,0xCCC,0xD41,0xDB6,0xE2B,0xEA0,0xF15,0xF8A,0xFFF};   // 360

static u16 rowh;

MAINMENU menu;

u8   Cur_Limit, Cur_Item, Cur_PopItem;
u8   Vbat_Flag = 1;
u8   Battery = 0, Unit = 60; 
u8   Label_Flag, Windows_Pop = 0, Windows_Flag = 0;
u8   Status = RUN;
u16  Depth;
u16  Background_Col = GRAY;  
u16  Vbat_Temp;
u8   Update[9]    = {1,1,1,1,1,1,1,1,1};
uc8  Menu_Limit[] = {7,6,6};            
uc8  Item_Base[8] = {0,7,13};

//----------------+------------------------+-----------------+
uc8 FnNote[][14]= {"File R/W OK!",          /*"ļ"   */
                   "File Ver Err",          /*"ļ汾"   */
                   "Not Found!  ",          /*"ļ"   */
                   "File R/W Err",          /*"ļ"   */
                   "Disk Busy!  ",          /*"̶д"   */
};
//----------------+------------------------+-----------------+

//------------FILE manage-----------------------------------------------------// 
uc8 FileStr[][20] = {
 "Save File  .Pam","Save File  .BMP","Save File  .DAT",
 "Save File  .BUF","Save File  .CSV","Load File  .DAT","Load File  .BUF",};

uc8 MeasStr[][8]  = {"Freq:","Duty:","Vrms:","Vavg:",
                     " Vpp:","Vmax:","Vmin:","Vbat:"};

//-----------˵Ŀ-----------------------------------------------------//
uc8 Menu_Str[][8] = {" Page1 ", "Oscillo", " Page2 ",
                     "Measure", " Page3 ", "Options"};
//-----------˵ѡ---------------------------------------------------------//
uc8 Item_Str[][10]= {
  "  CH_A   ",  "  CH_B   ",  "  CH_C   ", 
  "TimeBase ",  "Trigger  ",  "Cursors   ",  "Window    ",
  "         ",  "         ",  "         ",   "         ",  
  "         ",   "          ",
  " File    ",  " WaveOut ",  " System  ",  " Calibra ",
  " Product ",   " About   ",
};

uc8 Options_Str[][10]={
  " Manage  ",  " Option  ",  " Setting ",  " tion    ",  " Info    ",
};

//-------------ضʾ-----------------------------------------------------//
uc8  Cps_SYMB[][6]      = {"b", "a","_"};               //'~','-'
uc8  Scale_SYMB[][6]    = {"c", "d"};                   //x1,x10
uc8  Num_SYMB[][6]      = {"e", "f" ,"g" , "i" };       //"1", "2", "3", "F"
uc8  SYMB_2[][6]        = {"f"   , "i"};                //2 ͡F
uc8  SYMB_T[][6]        = {"h"   , "i"};                //T ͡F
uc8  Math_Str[][6]      = {" -A ", " -B ", "A+B ", "A-B ",
                           "RecA", "RecB", "RecC"};
uc8  Swintch[][7]       ={" ON  "," OFF  "};
uc8  Swintch1[][7]      ={"ON   ","OFF   "};
uc8  Swintch_V[][7]     ={" CH_A"," CH_B"," OFF "};
uc8  T0_Str[][7]        ={"  1  ","  2  ","  3  "};
uc8  Adc_Str[][7]       ={" AC  "," DC  "};
uc8  Math[][7]          ={" -A  ", " -B  ", " A+B ", " A-B ",
                          " RecA", " RecB", " RecC"};
uc8  Trig_SYMB[][6]     ={ "H",   "L" };
uc8  Trig_Str[][6]      ={ " {   ", " }   " };
uc8  TrigCH_Str[][8]    ={"CH_A  ","CH_B  "};
uc16 TRG_COLOR[]        ={RED,GRN,GRN,GRN,ORN};
uc8  Mode[][7]          ={"AUTO", "NORM" , "SNGL" , "SCAN" , "NONE" ,"STOP"};
uc8  Mode_Str[][7]      ={"AUTO ", "NORM " , "SNGL " ,
                          "SCAN " , "NONE " ,"STOP "};
uc8  Depth_Str[][7]     ={" 1K  ", " 2K  " , " 4K  " , " 8K  "};
uc8  Source_Str[][8]    ={"CH_A  ","CH_B  ","CH_3 "};
uc8  Wave_Str[][10]     ={"Squar   ","Sine    ","Triangle","Sawtooth"};
uc8  Freq_Str[][10]     ={" 10Hz    "," 20Hz    "," 50Hz    "," 100Hz   ",
                          " 200Hz   "," 500Hz   "," 1KHz    "," 2KHz    ",
                          " 5KHz    "," 10KHz   "," 20KHz   "," 50KHz   ",
                          " 100KHz  "," 200KHz  "," 500KHz  "," 1MHz    "};
uc8  Duty_Str [][10]    ={"  0%     "," 10%     "," 20%     "," 30%     ",
                          " 40%     "," 50%     "," 60%     "," 70%     ",
                          " 80%     "," 90%     "," 100%    "};
uc8  Vol_Str[][8]       ={" 10mV  "," 20mV  "," 50mV  "," 0.1V  "," 0.2V  ",
                          " 0.5V  "," 1.0V  "," 2.0V  "," 5.0V  "," 10V   "};
uc8  VolMenu_Str[][10]  ={"  10mV   ","  20mV   ","  50mV   ","  0.1V   ",
                          "  0.2V   ","  0.5V   ","  1.0V   ","  2.0V   ",
                          "  5.0V   ","   10V   "};
uc8  TimeBase_Str[][8]  ={"1.0uS","2.0uS","5.0uS","10uS ","20uS ","50uS ",
                          "0.1mS","0.2mS","0.5mS","1.0mS", 
                          "2.0mS","5.0mS","10mS ","20mS ","50mS ","0.1S ",
                          "0.2S ","0.5S ","1.0S ","2.0S "};
uc8  TimeBaseMenu_Str[][10]=
                         {" 1.0uS   "," 2.0uS   "," 5.0uS   ","  10uS   ",
                          "  20uS   ","  50uS   "," 0.1mS   "," 0.2mS   ",
                          " 0.5mS   "," 1.0mS   "," 2.0mS   "," 5.0mS   ",
                          "  10mS   ","  20mS   ","  50mS   ","  0.1S   ",
                          "  0.2S   ","  0.5S   ","  1.0S   ","  2.0S   "};


//--------------------------ԤƵ--------------------------------------
//----------+-------+-------+-------+-------+-------+-------+-------+-------+---
uc16 FPSC[] = {  128,  128,   64,   64,   16,   16,    4,    4,
                   1,    1,    1,    1,    1,    1,    1,    1};

uc16 FARR[] = {56250,28125,22500,11250,22500, 9000, 18000,9000,
               14400, 7200, 3600, 1440,  720,  360,  144,   72};
//----------+-------+-------+-------+-------+-------+-------+-------+-------+---
//--------------------------ģⲨηƵ------------------------------------
uc16 Dac_Psc[12] = {4,    2,    2,   2,   2,    2,   2,   2,    2,   2,   2};
uc16 Dac_Tim[12] = {10000,10000,4000,2000,1000, 400, 200, 100,  40,  100,  50};
//                   0-us                       9--ms                    18--1s
uc16 Ts[]        = {10,10,10,10,20,50,100,200,500,1,2,5,10,20,50,100,200,500,1,2};
uc16 DEPTH[]     = { 1024 , 2048 , 4096 , 8192};


uc32 VScale[]    = { 10,20, 50, 100, 200, 500, 1000, 2000, 5000,  10000};
uc32 TScale[]    = { 1,     2,    5,   10,    20,     50,                        
                     100, 200,  500,  1000, 2000,    5000,  10000, 20000, 50000, 
                     100000, 200000, 500000, 1000000, 2000000};                

//---Titleʾλ-----BAT| CH1| CH2| Ch3|  TB | TRI| AUTO--------------------//   
uc16 Title_Posi_X[] = { 6,   29,   83, 140, 180, 240, 289,  };

//------------ͨɫ----------------------
uc16 CH_Col[] = {CYN,YEL,PUR,ORN,CYN,RED,CYN};

//-------popmenu1 OSCILOSCOPE item--------------------------------------------//
uc8 PM1_str[][13] = {
 /*CH1*/        "Voltage:  ", "Post:     ", "AC/DC:    ",
                "Enable:   ","Fit:      ", 
 /*CH2*/        "Voltage:  ", "Post:     ", "AC/DC:    ",
                "Enable:   ","Fit:      ", 
 /*CH3*/        "Math:     ", "Post:     ", "Enable:   ",         
 /*Time*/       "TimeBase: ", "Fit:      ",
 /*Trig*/       "SyncMode: ", "TrigMode: ", "Source:   ",
                "Threshold:", "Enable:   ", "Auto Fit: ", 
 /*Cursor*/     "T1.Post:  ", "T2.Post:  ", "Enable.T: ",
                "V1.Post:  ", "V2.Post:  ", "Enable.V: ",
 /*Window*/     "Post:     ", "Depth:    ", "Enable:   ", "T0:       "
};
//-------popmenu3 SETTING item------------------------------------------------//
uc8 PM3_Str[][13]={
 "Save Param  ","Save   .BMP ","Save   .DAT ","Save   .BUF ","Save   .CSV ",
 "Load   .DAT ","Load   .BUF ",
 "Type:      ", "Freq:      ", "Duty:      ",
 "Volume:    ", "BKlight:    ","Standby:    ","PowerOff:  ","MenuCycle:",
 "ItemCycle:","PostSlide:",
 "Calibrate ",  "Restore   ",
 "          ","          ",
 "About:    ","          ", 
};
//====================PopmenuѡĿ=========================
//---Popmenu_1ѡĿ---CH1| CH2| CH3| TIME| TRI | CURS| WIN
uc8  PopMenu1_Base[]  = { 0,   5,  10,   13,   15,   21,  27};
uc8  PopMenu1_Limit[] = { 4,   4,   3,    1,    6,    6,   3};//رT0 Fit
//---Popmenu_3ѡĿ---FILE| WAVE| SYS | CAL | PRO| ABOUT
uc8  PopMenu3_Base[]  = { 0,    7,   10,    17,   19,   21}; 
uc8  PopMenu3_Limit[] = { 7,    3,    7,     2,    2,    2};

//====================Menu1_Popmenu========================= 
//--------------Popmenuѡ------------------------

sc16 Popmenu1_Limit1[]={
//======+====+=====+======+=====+=====+=======+   
//CH1    VOL | POST| AC/DC| FIT | ENABLE
          9,   195,    1,    1,     1,   
//CH2    VOL | POST| AC/DC| FIT | ENABLE     
          9,   195,    1,    1,     1,
//CH3   TYPE | POTS| SWITCH        
          6,   195,    1,
//TIME  TIME | FIT
         19,     1,                           
//TRIG  MODE | TYPE| OURCE| THR1  FIT | ENABLE |THR2
          4,     1,    1,   95,   1,     1,    95,
//CURS   T1  |  T2 |  EN_T|  V1 |  V2 | EN_V        
        248,   248,    1,   198, 198,     2, 
//WIN   POSI |DEPTH| EN | T0_Str
        7939,     3,    1,  2,                         
};
//--------------Popmenuѡ------------------------
sc16 PopMenu1_Limit2[]={ 
  1,  5,  0,   0,  0,           //CH1     VOL | POST| AC/DC| FIT | ENABLE
  1,  5,  0,   0,  0,           //CH2     VOL | POST| AC/DC| FIT | ENABLE
  0,  5,  0,                    //CH3    TYPE | POTS| SWITCH 
  0,  0,                        //Time   TIME | FIT
  0,  0,  0, -95,  0,  0,  -95, //Trig   MODE | TYPE| OURCE| THRI| FIT |ENABLE|THR2
  5,  5,  0,   2,  2,  0,       //Curs    T1  |  T2 |  EN_T|  V1 |  V2 |EN_V 
  0,  0,  0,   0,               //Win    POSI |DEPTH| EN   |   T0_Str
};
//--------------PopmenuѡĬֵ------------------------
s16 PopMenu1_Value[]={
  7,  100,  0,  0,  1,        //CH1     VOL | POST| AC/DC| FIT | ENABLE
  7,   85,  0,  0,  1,        //CH2     VOL | POST| AC/DC| FIT | ENABLE
  2,   30,  1,                //CH3    TYPE | POTS| SWITCH
  7,    1,                    //Time   TIME | FIT
  0,    0,  0, 10,   0,  1, 8,//Trig   MODE | TYPE| CH_N | THRI| FIT |ENABLE|THR2
  50, 200,  0,175,  25,  0,   //Curs    T1  |  T2 | EN_T |  V1 |  V2 |EN_V 
  0,    2,  0,  0,            //Win    POSI |DEPTH| EN           
};
sc16 PopMenu1_CValue[]={
  7,  100,  0,  0,  1,        //CH1     VOL | POST| AC/DC| FIT | ENABLE
  7,   85,  0,  0,  1,        //CH2     VOL | POST| AC/DC| FIT | ENABLE
  2,   30,  1,                //CH3    TYPE | POTS| SWITCH
  7,    1,                    //Time   TIME | FIT
  0,    0,  0, 10,   0,  1, 8,//Trig   MODE | TYPE| CH_N | THRI| FIT |ENABLE|THR2
  50, 200,  0,175,  25,  0,   //Curs    T1  |  T2 | EN_T |  V1 |  V2 |EN_V 
  0,    2,  0,  0,            //Win    POSI |DEPTH| EN           
};

//--------------Popmenu_Posiλ------------------------ 
uc8 PopMenu1_Posi_Y[]={
   75,  70, 70,  60,  30,  20,  10,	
}; 
uc8 PopMenu1_Posi_X[]={
   145,   145,  145,  145,  145,  145,  145,  
};
uc8 PopMenu3_Posi_X[]={	
   163,  145, 145,  145,  120,  120,  120,	
};

//**************Menu3_Pop**************************************** 
uc16 PopMenu3_Limit1[]={// 
  99, 99, 99, 99, 99, 99, 99,    //File   Pam | BMP | DAT | BUF | CSV | DAT |BUF 
  3, 15,  9,                     //Wave   TYPE| FRQ | DUTY| 
  9,  10, 30, 30, 1, 1, 1,       //Sys    VOL | BK  | STANDBY   | PowerOff
};
uc16 PopMenu3_Limit2[]={// 
  0,  0,  0,  0,  0,  0,  0,
  0,  0,  1,  
  0,  1,  0, 0,	0, 0, 0,
};
u8 PopMenu3_Value[]={   //Ĭ
  0,  0,  0,  0,  0,  0,  0,
  0,  6,  5,  
  5,  5,  0, 0,	1, 1, 1,
};
uc8 PopMenu3_CValue[]={ //Ĭ
  0,  0,  0,  0,  0,  0,  0,
  0,  6,  5,  
  5,  5,  0, 0,	1, 1, 1,
};	

//------PopMenu2 measurement item---------------------------------------------//

uc8 PopMenu2[][13]      = {"Source:   ", "Type:     ","Enable:   "};
uc8 MeasItem[][9]       = {"FREQ   ", "DUTY   ", "RMS    ", "Vavg  ", "VPP    ",
                           "Max    ", "Min    ", "VBAT   "};
uc8 MeasItem_Menu[][10] = {"  FREQ   ", "  DUTY   ", "  RMS    ", "  Vavg   ",
                           "  VPP    ", "  Max    ", "  Min    ", "  VBAT   "};

uc16 PopMenu2_Limit1[]={1,  6,  1,    //  // ڶѡ7 6ĻرVBat
                        1,  6,  1,
                        1,  6,  1,
                        1,  6,  1,
                        1,  6,  1,
                        1,  6,  1,
};
uc16 PopMenu2_Limit2[]={0,  0,  0,        
                        0,  0,  0,
                        0,  0,  0,
                        0,  0,  0,
                        0,  0,  0,
                        0,  0,  0,
};
u8  PopMenu2_Value[]={               
                        0,  0,  0,                        //source CH1
                        1,  1,  0,                        //type
                        0,  2,  0,                        //enable
                        0,  3,  0,                        //source CH1
                        0,  4,  0,                        //type
                        0,  5,  0,                        //enable
};
uc8  PopMenu2_CValue[]={               
                        0,  0,  0,                        //source CH1
                        1,  1,  0,                        //type
                        0,  2,  0,                        //enable
                        0,  3,  0,                        //source CH1
                        0,  4,  0,                        //type
                        0,  5,  0,                        //enable
};

/*******************************************************************************
show menu: ʾ˵
*******************************************************************************/
void Show_Menu(void)
{
  u16 k, n, item;
  u8* ptr; 
  if (!(menu.mflag & UPD) && !(menu.iflag &UPD)) return;
  //------show menu------------------------------------  
  if(menu.mflag & UPD){
    menu.mflag &=~UPD;
    menu.iflag |= UPD;
    Background=CYN; 
    Foreground=WHT;
    Clear_Label_R(DAR);                                //  
    Draw_Circle_D(RED,  Menu_X, Menu_Y, 38, 53, 56);  //˵ҳο
    ptr=(u8*)&Menu_Str[menu.current*2];
    Background=RED; 
    Foreground=WHT;     
    //------ʾҳ------------ 
    Sy =Menu_Y+20 ; 
    Sx =Menu_X;
    PrintStr(PRN, ptr);
    Sy =Menu_Y+6 ; 
    Sx =Menu_X;
    ptr+=8;
    PrintStr(PRN, ptr);
  }
  if (!(menu.iflag & UPD)) return;
  menu.iflag &=~UPD;
  //------show item------------------------------------------// 
  if(menu.current==Measure){
    Show_Measure();
  }
  else{
    item=Item_Base[menu.current];
    ptr=(u8*)&Item_Str[item];   
    rowh=0;
    for(n=0; n<Menu_Limit[menu.current]; n++){
      if(menu.menu_index[menu.current]==n)Background=GRN;
      else  Background=WHT;      
      Foreground=BLK;
      Sx=Menu_X+8;             
      rowh+=RowHeight;
      Sy=ITEM_Y-rowh;
      Draw_Rectangle(Background, Menu_X+8, ITEM_Y-rowh+11, 3, 49); 
      PrintStr6x8(PRN, ptr);
      ptr+=10;                
      Sx=Menu_X+8;
      k = item+n;
      if((k!=CH3)&&(k!=COURSOR)&&(k!=WINDOWS)&&(k!=ABOUT)){
        rowh+=RowHeight;
        Draw_Rectangle(Background, Menu_X+8, ITEM_Y-rowh, 3, 49); 
      }
      Show_Item(k);                         //max=16  item+nΪPopĵk
    }
  }
}

/*******************************************************************************
 show item : ʾ˵     ˵ǰ
*******************************************************************************/
void Show_Item(u8 k)
{

  u8  wink;
  u16 x,y,j;
    switch (k){
    case CH1:
      wink = (PopMenu1_Value[CH1_Fit])? PRN : VOID; //Fģʽʱ
      Sy=ITEM_Y-rowh+3;
      PrintStr6x8(wink, (u8*)VolMenu_Str[PopMenu1_Value[CH1_Vol]]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(CH_Col[k], Menu_X, Sy, 28, 6);  //Ŀɫ
      wink = (PopMenu1_Value[CH1_Fit])? INV : INV;  //Fģʽʱ
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+8, TITLE_H+2, 11, 2, 7*6);
      SetColor(DAR,CH_Col[k]);
      DispStr(Title_Posi_X[k+1]-1, TITLE_H+2, SYMB,
             (PopMenu1_Value[CH1_Fit]?(u8*)("_"):(u8*)("i")));
      DispStr6x8(Title_Posi_X[k+1]+11,TITLE_H+2, wink,(PopMenu1_Value[CH1_Enable]?
                (u8*)("Hide "):(u8*)(Vol_Str[PopMenu1_Value[CH1_Vol]]+1)));
      DispStr(Title_Posi_X[k+1]+40, TITLE_H+2, wink+SYMB,
             (u8*)(Cps_SYMB[PopMenu1_Value[CH1_Coupl]]));
      break;  
    case CH2:
      wink = (PopMenu1_Value[CH2_Fit])? PRN : VOID; //Fģʽʱ
      Sy=ITEM_Y-rowh+3;
      PrintStr6x8(wink, (u8*)VolMenu_Str[PopMenu1_Value[CH2_Vol]]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(CH_Col[k], Menu_X, Sy, 28, 6);  //Ŀɫ
      SetColor(DAR,CH_Col[k]);
      wink = (PopMenu1_Value[CH2_Fit])? INV : INV;  //Fģʽʱ
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+8, TITLE_H+2, 11, 2, 7*6);
      DispStr(Title_Posi_X[k+1]-1, TITLE_H+2, SYMB,
             (PopMenu1_Value[CH2_Fit]?(u8*)("_"):(u8*)("i")));
      DispStr6x8(Title_Posi_X[k+1]+ 7+4,TITLE_H+2 ,wink,(PopMenu1_Value[CH2_Enable]?
                (u8*)("Hide "):(u8*)(Vol_Str[PopMenu1_Value[CH2_Vol]]+1)));
      DispStr(Title_Posi_X[k+1]+40, TITLE_H+2, wink+SYMB,
             (u8*)(Cps_SYMB[PopMenu1_Value[CH2_Coupl]]));              
      break;
    case CH3: 
      Draw_Circle_S(CH_Col[k], Menu_X, Sy, 14, 6);  //Ŀɫ
      SetColor(DAR,CH_Col[k]);    
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+8, TITLE_H+2, 11, 2, 5*6-1);
      DispStr6x8(Title_Posi_X[k+1]+12,TITLE_H+2,INV,(PopMenu1_Value[CH3_Enable]?
                (u8*)("Hide"):(u8*)(Math_Str[PopMenu1_Value[CH3_Type]])));
      break;
    case TIMEBASE:        
      wink = (PopMenu1_Value[TIM_Fit])? PRN : VOID; //Fģʽʱ
      Sy=ITEM_Y-rowh+3;
      PrintStr6x8(wink, (u8*)&TimeBaseMenu_Str[PopMenu1_Value[TIM_Base]]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(CH_Col[k], Menu_X, Sy, 28, 6);  //Ŀɫ
      SetColor(DAR,CH_Col[k]);
      DispStr(Title_Posi_X[k+1], TITLE_H+2, SYMB,
             (PopMenu1_Value[TIM_Fit]?(u8*)("_"):(u8*)("i")));
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+10, TITLE_H+2, 11, 2, 6*6-1);  
      DispStr6x8(Title_Posi_X[k+1]+13, TITLE_H+2, INV,
                (u8*)&TimeBase_Str[PopMenu1_Value[TIM_Base]]);
      break;
    case TRIGGER:
      Sx=Menu_X;
      Sy=ITEM_Y-rowh;
      PrintStr(PRN, "       ");
      Sx=Menu_X+24;
      SetColor(DAR, CH_Col[PopMenu1_Value[TRI_Ch]]);
      PrintStr(PRN+SYMB, (u8*)&Trig_SYMB[PopMenu1_Value[TRI_Mode]]);
      Draw_Circle_S(CH_Col[PopMenu1_Value[TRI_Ch]], Menu_X, Sy, 28, 6);
      SetColor(DAR,CH_Col[PopMenu1_Value[TRI_Ch]]);
      Sx=Title_Posi_X[k+1];
      Sy=TITLE_H+2;
      Draw_Circle_D(CH_Col[PopMenu1_Value[TRI_Ch]], 
                    Title_Posi_X[k+1]-3, TITLE_H+2, 11, 2, 6*6+1);
      if(PopMenu1_Value[TRI_Fit])PrintStr6x8(INV, "Trig");
      else{ 
        PrintStr6x8(INV, "Trig");
      }  
      DispStr(Title_Posi_X[k+1]+24, TITLE_H+2,INV+ SYMB, 
             (u8*)&Trig_SYMB[PopMenu1_Value[TRI_Mode]]);
      DispStr(Title_Posi_X[k+1]-12, TITLE_H+2, SYMB,
             (PopMenu1_Value[TRI_Fit]?(u8*)("_"):(u8*)("i")));
      Update_Status();
      break;
    case COURSOR:
      Draw_Circle_S(CH_Col[k], Menu_X, Sy, 14, 6);//Ŀɫ
      break;
    case WINDOWS:
      Draw_Circle_S(CH_Col[k], Menu_X, Sy, 14, 6);//Ŀɫ
      break;
 //-------------------ҳ------------------------------------------
    case FILE:
      Sx=Menu_X+8;                                //˵
      Sy=ITEM_Y-rowh+3;
      PrintStr6x8(PRN, (u8*)&Options_Str[k-FILE]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(CH_Col[0], Menu_X, Sy, 28, 6);//Ŀɫ
      break;
    case WAVE:
      Sx=Menu_X+8;                                //˵
      Sy=ITEM_Y-rowh+3; 
      PrintStr6x8(PRN, (u8*)&Options_Str[k-FILE]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(CH_Col[1], Menu_X, Sy, 28, 6);//Ŀɫ
      break;
    case SYSTEM:
      Sx=Menu_X+8;                                //˵
      Sy=ITEM_Y-rowh+3;      
      PrintStr6x8(PRN, (u8*)&Options_Str[k-FILE]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(CH_Col[2], Menu_X, Sy, 28, 6);//Ŀɫ
      break;
    case CALIBRATION:
      Sx=Menu_X+8;                                //˵
      Sy=ITEM_Y-rowh+3;      
      PrintStr6x8(PRN, (u8*)&Options_Str[k-FILE]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(ORN, Menu_X, Sy, 28, 6);      //Ŀɫ
      break;
    case PRO:
      Sy=ITEM_Y-rowh+3;
      PrintStr6x8(PRN, (u8*)&Options_Str[k-FILE]);
      Sy=ITEM_Y-rowh;
      Draw_Circle_S(BLU, Menu_X, Sy, 28, 6);      //Ŀɫ
      break;
    case ABOUT:
      Draw_Circle_S(RED, Menu_X, Sy, 14, 6);      //Ŀɫ
      break;
    }
    rowh++;
    x=Menu_X+2;
    y=ITEM_Y-rowh;
    for(j=0; j<58; j++){                          //߼
      SetPosi(x++, y);
      SetPixel(BLK);
    }
}
/*******************************************************************************
 Show_Title: ʾ    
*******************************************************************************/
void Show_Title(void)
{
  u8  wink;
  u16 k;
  for(k=0;k<7;k++){
    switch (k){
    case CH1:
      wink = (PopMenu1_Value[CH1_Fit])? INV : INV; //Fģʽʱ
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+8, TITLE_H+2, 11, 2, 7*6);
      SetColor(DAR,CH_Col[k]);
      DispStr(Title_Posi_X[k+1]-1, TITLE_H+2, SYMB,
             (PopMenu1_Value[CH1_Fit]?(u8*)("_"):(u8*)("i")));
      DispStr6x8(Title_Posi_X[k+1]+11, TITLE_H+2, wink,(PopMenu1_Value[CH1_Enable]?
                (u8*)("Hide "):(u8*)(Vol_Str[PopMenu1_Value[CH1_Vol]]+1)));
      DispStr(Title_Posi_X[k+1]+40, TITLE_H+2, wink+SYMB, 
             (u8*)(Cps_SYMB[PopMenu1_Value[CH1_Coupl]]));             
      break;  
    case CH2:
      SetColor(DAR,CH_Col[k]);
      wink = (PopMenu1_Value[CH2_Fit])? INV : INV; //Fģʽʱ
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+8, TITLE_H+2, 11, 2, 7*6);
      DispStr(Title_Posi_X[k+1]-1, TITLE_H+2, SYMB,
             (PopMenu1_Value[CH2_Fit]?(u8*)("_"):(u8*)("i")));
      DispStr6x8(Title_Posi_X[k+1]+ 7+4, TITLE_H+2, wink,(PopMenu1_Value[CH2_Enable]?
                (u8*)("Hide "):(u8*)(Vol_Str[PopMenu1_Value[CH2_Vol]]+1)));
      DispStr(Title_Posi_X[k+1]+40, TITLE_H+2, wink+SYMB, 
             (u8*)(Cps_SYMB[PopMenu1_Value[CH2_Coupl]]));                   
      break;
    case CH3:
      SetColor(DAR,CH_Col[k]);    
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+8, TITLE_H+2, 11, 2, 5*6-1);
      DispStr6x8(Title_Posi_X[k+1]+12, TITLE_H+2, INV, (PopMenu1_Value[CH3_Enable]?
                (u8*)("Hide"):(u8*)(Math_Str[PopMenu1_Value[CH3_Type]])));
      break;
    case TIMEBASE:        //TimeBs
      SetColor(DAR,CH_Col[k]);
      DispStr(Title_Posi_X[k+1], TITLE_H+2, SYMB,
              (PopMenu1_Value[TIM_Fit]?(u8*)("_"):(u8*)("i")));
      Draw_Circle_D(CH_Col[k], Title_Posi_X[k+1]+10, TITLE_H+2, 11, 2, 6*6-1); 
      DispStr6x8(Title_Posi_X[k+1]+13, TITLE_H+2, INV, 
                (u8*)&TimeBase_Str[PopMenu1_Value[TIM_Base]]);
      break;
    case TRIGGER:
      SetColor(DAR,CH_Col[PopMenu1_Value[TRI_Ch]]);
      Sx=Title_Posi_X[k+1];
      Sy=TITLE_H+2;
      Draw_Circle_D(CH_Col[PopMenu1_Value[TRI_Ch]], 
                    Title_Posi_X[k+1]-3, TITLE_H+2, 11, 2, 6*6+1);//ǰ߿ 
      if(PopMenu1_Value[TRI_Fit])PrintStr6x8(INV, "Trig");
      else{ 
        PrintStr6x8(INV, "Trig");
      }  
      DispStr(Title_Posi_X[k+1]+24, TITLE_H+2,INV+ SYMB, 
             (u8*)&Trig_SYMB[PopMenu1_Value[TRI_Mode]]);
      DispStr(Title_Posi_X[k+1]-12, TITLE_H+2, SYMB,
             (PopMenu1_Value[TRI_Fit]?(u8*)("_"):(u8*)("i")));
      Update_Status();
      break;
    case COURSOR:
      break;
    case WINDOWS:
      break;
    case FILE:
      break;
    case WAVE:
      break;
    case SYSTEM:
      break;
    case CALIBRATION:
      break;
    case PRO:
      break;
    case ABOUT:
      break;
    }
  }
}
/*******************************************************************************
ʾӲ˵Ŀ¼ 
*******************************************************************************/
void Show_PopMenu(u8 Cur_Item)
{
  #define LEN 9
  u16 i,j,index;
  u8  *ptr1,*ptr2;
  u8  ptr[64],ptr3[6], item = 0;
  
  memset(ptr,0,64);
  switch (menu.current){
    //----------------------------һҳ˵----------------------------------//
  case Oscillo:
    j=menu.menu_index[menu.current];
    Cur_Limit=PopMenu1_Limit[j];
    index=PopMenu1_Base[j];
    ptr1=(u8*)&PM1_str[index];
    switch (j){
    case CH1:
      memcpy(&ptr," ",1);
      ptr2=(u8*)&Vol_Str[PopMenu1_Value[CH1_Vol]];                //Ch_range
      memcpy(&ptr[1],&ptr2[1],LEN-5);
      memcpy(&ptr[LEN]," ",1);
      sprintf((char*)ptr3,"%-3d",PopMenu1_Value[CH1_Posi]);       //Ch_posi
      strcat((char*)ptr3," ");
      memcpy(&ptr[LEN+1],ptr3,5);
      memcpy(&ptr[2*LEN],&Adc_Str[PopMenu1_Value[CH1_Coupl]],5);  //Ch_AD~DC
      memcpy(&ptr[3*LEN],&Swintch[PopMenu1_Value[CH1_Enable]],5); //Ch_Enable 
      memcpy(&ptr[4*LEN],&Swintch[PopMenu1_Value[CH1_Fit]],5);    //Ch_Fit
      break;
    case CH2:
      memcpy(&ptr," ",1);
      ptr2=(u8*)&Vol_Str[PopMenu1_Value[CH2_Vol]];                //Ch_range
      memcpy(&ptr[1],&ptr2[1],LEN-5);
      memcpy(&ptr[LEN]," ",1);
      sprintf((char*)ptr3,"%-3d",PopMenu1_Value[CH2_Posi]);       //Ch_posi
      strcat((char*)ptr3," ");
      memcpy(&ptr[LEN+1],ptr3,5);
      memcpy(&ptr[2*LEN],&Adc_Str[PopMenu1_Value[CH2_Coupl]],5);  //Ch_AD~DC
      memcpy(&ptr[3*LEN],&Swintch[PopMenu1_Value[CH2_Enable]],5); //Ch_Enable 
      memcpy(&ptr[4*LEN],&Swintch[PopMenu1_Value[CH2_Fit]],5);    //Ch_Fit
      break;
    case CH3:
      memcpy(&ptr,(u8*)&Math[PopMenu1_Value[CH3_Type]],LEN-3);
      memcpy(&ptr[LEN]," ",1);
      sprintf((char*)ptr3,"%-3d",PopMenu1_Value[CH3_Posi]);
      strcat((char*)ptr3," ");
      memcpy(&ptr[LEN+1],ptr3,5);
      memcpy(&ptr[2*LEN],&Swintch[PopMenu1_Value[CH3_Enable]],5);
      break;
    case TIMEBASE:
      ptr2=(u8*)&TimeBaseMenu_Str[PopMenu1_Value[TIM_Base]];   //TimeBase_range
      memcpy(&ptr,&ptr2[1],LEN-4);
      memcpy(&ptr[LEN],&Swintch[PopMenu1_Value[TIM_Fit]],5);   //TimeBase_Fit 
      break;          
    case TRIGGER:
      memcpy(&ptr,(u8*)&Mode_Str[PopMenu1_Value[TRI_Sync]],LEN-3);
      memcpy(&ptr[LEN],(u8*)&Trig_Str[PopMenu1_Value[TRI_Mode]],LEN-4);        
      memcpy(&ptr[2*LEN],(u8*)&TrigCH_Str[PopMenu1_Value[TRI_Ch]],LEN-4);
      sprintf((char*)ptr3,"%-3d",(PopMenu1_Value[TRI_Ch])?
              PopMenu1_Value[TRI_Ch2]:PopMenu1_Value[TRI_Ch1]);
      strcat((char*)ptr3,"  ");
      memcpy(&ptr[3*LEN],ptr3,5);
      memcpy(&ptr[4*LEN],&Swintch1[PopMenu1_Value[TRI_Enable]],5);
      memcpy(&ptr[5*LEN],&Swintch1[PopMenu1_Value[TRI_Fit]],5);
      break;
    case COURSOR:
      index++;
      for(i=0;i<6;i++){
        if     (i==2)memcpy(&ptr[i*LEN],Swintch[PopMenu1_Value[index++]],5);
        else if(i==5)memcpy(&ptr[i*LEN],Swintch_V[PopMenu1_Value[index++]],5);
        else{
          memcpy(&ptr[i*LEN]," ",1);
          sprintf((char*)ptr3,"%-3d",PopMenu1_Value[index++]);
          strcat((char*)ptr3," ");
          memcpy(&ptr[i*LEN+1],ptr3,5);
        }
      }
      break;
    case WINDOWS:
      index++;
      Windows_Flag |=UPD;
      Update_Windows();  //λôpopmenu1_valueи
      sprintf((char*)ptr3,"%3d",PopMenu1_Value[WIN_Posi]);
      strcat((char*)ptr3,"  ");
      memcpy(&ptr,ptr3,5);
      memcpy(&ptr[LEN],(u8*)&Depth_Str[PopMenu1_Value[WIN_Depth]],LEN-3);
      memcpy(&ptr[2*LEN],&Swintch[PopMenu1_Value[WIN_Enable]],5);
      memcpy(&ptr[3*LEN],&T0_Str[PopMenu1_Value[WIN_T0]],5);
      break; 
    }
    PMenu_Pop(Cur_Limit,Cur_Item,ptr1,10,ptr);
    break;
    //---------------------------ڶҳ˵----------------------------------//
  case Measure:
    j=menu.menu_index[menu.current];
    Cur_Limit=3;
    index=j*3;
    ptr1=(u8*)&PopMenu2;
    memcpy(&ptr,(u8*)(Source_Str[PopMenu2_Value[index++]]),LEN-4);
    memcpy(&ptr[LEN],(u8*)&MeasItem[PopMenu2_Value[index++]],LEN-4);
    ptr[2*LEN-2]=0;
    memcpy(&ptr[2*LEN],(u8*)&Swintch1[PopMenu2_Value[index]],LEN-4);
    if(j<5) //һصѹĿӴ
    PMenu_Pop(Cur_Limit,Cur_Item,ptr1,10,ptr);
    break;
    //---------------------------ҳ˵-----------------------------------//
  case Option:
    item=menu.menu_index[menu.current]; 
    j=Item_Base[menu.current]+item;
    Cur_Limit=PopMenu3_Limit[item];
    index=PopMenu3_Base[item];
    ptr1=(u8*)&PM3_Str[index];
    switch(j){
    case FILE:
      FMenu_Pop(Cur_Limit,Cur_Item,ptr1);
      break;
    case WAVE:
      ptr2=(u8*)&Wave_Str[PopMenu3_Value[WAVE_Type]]; 
      memcpy(&ptr,&ptr2[0],LEN-1);
      ptr2=(u8*)&Freq_Str[PopMenu3_Value[WAVE_Freq]]; 
      memcpy(&ptr[LEN],&ptr2[1],LEN-1); 
      ptr2=(u8*)&Duty_Str[PopMenu3_Value[WAVE_Duty]]; 
      memcpy(&ptr[LEN*2],&ptr2[1],LEN-1);         
      sprintf((char*)ptr3,"%2d",PopMenu3_Value[WAVE_Duty]);  
      memcpy(&ptr[LEN*3],ptr3,2);
      PMenu_Pop(Cur_Limit,Cur_Item,ptr1,7,ptr);
      break;
    case SYSTEM:
      ptr2=(u8*)&Duty_Str[PopMenu3_Value[SYS_Volume]]; 
      memcpy(&ptr,&ptr2[0],LEN-3);
      ptr2=(u8*)&Duty_Str[PopMenu3_Value[SYS_BKLight]]; 
      memcpy(&ptr[LEN],&ptr2[0],LEN-3);
      sprintf((char*)ptr3,"%2d",PopMenu3_Value[SYS_Standy]);
      strcat((char*)ptr3,"min ");
      memcpy(&ptr[LEN*2],ptr3,6);
      sprintf((char*)ptr3,"%2d",PopMenu3_Value[SYS_PowerOff]);
      strcat((char*)ptr3,"min ");
      memcpy(&ptr[LEN*3],ptr3,6);
      memcpy(&ptr[LEN*4],":",1);
      memcpy(&ptr[LEN*4+1],(u8*)&Swintch1[PopMenu3_Value[SYS_MenuCyc]],5);
      memcpy(&ptr[LEN*5],":",1);
      memcpy(&ptr[LEN*5+1],(u8*)&Swintch1[PopMenu3_Value[SYS_ItemCyc]],5);
      memcpy(&ptr[LEN*6],":",1);
      memcpy(&ptr[LEN*6+1],(u8*)&Swintch1[PopMenu3_Value[SYS_PosiSlide]],5);
      PMenu_Pop(Cur_Limit,Cur_Item,ptr1,9,ptr);
      break;
    case CALIBRATION:
      memcpy(&ptr,     " Zero ",6);
      memcpy(&ptr[LEN]," Data ",6);
      PMenu_Pop(Cur_Limit,Cur_Item,ptr1,9,ptr);
      break;
    case PRO:
      Product_Pop("Product Info", 105, 20, 96, 23*6);
      break;
    case ABOUT:  
      if(About_Flag){
        About_Flag =0;
      }
      else About_Flag =1;
      if(About_Flag){
        Open_Bmp(0);
      }
      else{
        Label_Flag  |= UPD;
        Update_Label();
      } 
      break;
    }
    break;
  }
}

/*******************************************************************************
ʾڶҳ˵ 
*******************************************************************************/
void Show_Measure(void)
{
  u8 *ptr;
  int j,k;
  s16 x,y;
  u8  source,type,enable;
  rowh=0;
  
  if(Vbat_Flag == 1){
    Vbat_Temp = Vbat;
    Vbat_Flag = 0;
  }
  for(k=0; k<6; k++){
    source = PopMenu2_Value[k*3];
    type   = PopMenu2_Value[k*3+1];
    enable = PopMenu2_Value[k*3+2];
    Foreground=BLK;
    if(menu.menu_index[menu.current]==k)Background=GRN;
    else {
      if(enable==0){ Background=WHT;  Foreground=BLK;}
      else          {Background=GRY; }
    }
    Sx=Menu_X+6;
    rowh+=RowHeight;
    Sy=ITEM_Y-rowh;
    ptr=(u8*)&MeasItem_Menu[type];
    if(k==5){
      DispStr6x8(Sx+2, Sy,  PRN, "         ");
      Sx=Menu_X+6;
      DispStr6x8(Sx+2, Sy, SYMB, "':");         //ʾط 
      Sx=Menu_X+21;
      Sy=ITEM_Y-rowh;
      if(__Info(P_VUSB)>4200){
        if((Vbat > Vbat_Temp) && ((Vbat - Vbat_Temp) < 500))Vbat_Temp = Vbat;
      }else{
        if((Vbat < Vbat_Temp) && ((Vbat_Temp - Vbat) < 500))Vbat_Temp = Vbat;
      }
      Value2Str(NumStr, Vbat_Temp*1000, (u8*)YSTR, 3, STD);
      ptr = NumStr;
    }
    DispStr6x8(Sx, Sy, PRN, ptr); 
    Draw_Rectangle(Background, Menu_X+8, ITEM_Y-rowh+11, 3, 49); 
    Sx=Menu_X+6;
    rowh+=RowHeight;
    Sy=ITEM_Y-rowh;
    if(k<5)PrintStr(PRN, "       ");
    MeasureStr(source,type);
    //===ͨɫ====ɵDreaw_Circle_S()Բ  
    Sx=Menu_X+8;Sy=ITEM_Y-rowh+3;
    if(k<5){
      DispStr6x8(Sx, Sy, PRN, NumStr);    
      Draw_Circle_S(CH_Col[source], Menu_X, ITEM_Y-rowh, 28, 6);//Ŀɫ
    }
    else if(k==5) Draw_Circle_S(CH_Col[source], Menu_X, ITEM_Y-rowh+14, 14, 6);
    //==============
    rowh++;
    x=Menu_X+2; //Menu
    y=ITEM_Y-rowh;
    if(k<5)
      for(j=0; j<58; j++){
        SetPosi(x++, y);
        SetPixel(BLK);
      }
  }
  Foreground=BLK;
}

/*******************************************************************************
Ŀ¼ 
*******************************************************************************/
void PMenu_Proc(u8 mode,u8 Cur_Item,u8 step)
{
  s16 j,index,limit;
  u8 item=0;
  if(Windows_Pop==0){
    menu.iflag|=UPD;
    Label_Flag|=UPD;
  }
  switch (menu.current){
  //------------------------------һҳ˵----------------------------------//
  case Oscillo:
    j=menu.menu_index[menu.current];
    index=PopMenu1_Base[j]+Cur_PopItem-1;
    //---------------ģʽ---------------
    if (mode==add){ 
     // +++++++++indexΪThresholdʱ++++++++++++++++
      if(index != TRI_Ch1){   
        if(index>TRI_Fit)index++; //Ϊtri2index+1
        limit=Popmenu1_Limit1[index]-step;
        if(index==CH1_Posi){     //Ch1λϵģʽ
          if((PopMenu1_Value[CH1_Posi]<195)
             &&((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])>195+step)){
            PopMenu1_Value[TRI_Ch1]--;
            PopMenu1_Value[CH1_Posi]++;
          }else if(PopMenu1_Value[CH1_Posi]<limit)
            PopMenu1_Value[CH1_Posi]++;
        }
        else if(index==CH2_Posi){//Ch2λϵģʽ
          if((PopMenu1_Value[CH2_Posi]<195)
             &&((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])>195+step)){
            PopMenu1_Value[TRI_Ch2]--;
            PopMenu1_Value[CH2_Posi]++;
          }else if(PopMenu1_Value[CH2_Posi]<limit)
            PopMenu1_Value[CH2_Posi]++;
        }
       else if(index==WIN_Posi){
         switch(PopMenu1_Value[WIN_Depth]){ //ͬWIN_Posi
         case 0:
           limit = 774-55; 
           break;
         case 1:
           limit = 1798-55;
           break;
         case 2:
           limit = 3846-55;
           break;
         case 3:
           limit = 7939-55;
           break;
         }
         if((PopMenu1_Value[TRI_Sync]!= NONE)
            &&(PopMenu1_Value[TRI_Sync]!= SCAN)){
           if(step!=0) PopMenu1_Value[index]+=step;
           else if(PopMenu1_Value[index]<limit)PopMenu1_Value[index]+=5;
         }
       } 
        else if(PopMenu1_Value[index]<limit){   //ѡϵģʽ
          if(step!=0) PopMenu1_Value[index]+=step;
          else        PopMenu1_Value[index]++;
        }else if(!PopMenu3_Value[SYS_ItemCyc]) {//ѡѭģʽ
          if((index!=CH1_Vol)&&(index!=CH2_Vol)&&(index!=TIM_Base))
            PopMenu1_Value[index]=PopMenu1_Limit2[index];
        }
      }
      //++++++++indexΪThresholdʱ+++++++++++
      else{           
        if(PopMenu1_Value[TRI_Ch]){   //triggerΪch2ǣӦֵ  
          if((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])<195+step){
            if(step!=0) PopMenu1_Value[TRI_Ch2]+=step;
            else        PopMenu1_Value[TRI_Ch2]++;
          }
        }
        else{                         //triggerΪch1ǣӦֵ
          if((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])<195+step){
            if(step!=0) PopMenu1_Value[TRI_Ch1]+=step;
            else        PopMenu1_Value[TRI_Ch1]++;
          }
        }
      }     
    }
    //-------------ģʽ ------------------
    else{
      if(index != TRI_Ch1){           // indexΪThresholdʱ
        if(index>TRI_Fit)index++;
        limit=PopMenu1_Limit2[index]+step;
        
        if(index==CH1_Posi){
          if((PopMenu1_Value[CH1_Posi]>5)
             &&((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])<5+step)){
            PopMenu1_Value[TRI_Ch1]++;
            PopMenu1_Value[CH1_Posi]--;
          }else if(PopMenu1_Value[CH1_Posi]>limit)
            PopMenu1_Value[CH1_Posi]--;
        }
        else if(index==CH2_Posi){
          if((PopMenu1_Value[CH2_Posi]>5)
             &&((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])<5+step)){
            PopMenu1_Value[TRI_Ch2]++;
            PopMenu1_Value[CH2_Posi]--;
          }else if(PopMenu1_Value[CH2_Posi]>limit)
            PopMenu1_Value[CH2_Posi]--;
        } 
        else if(index==WIN_Posi){
          if((PopMenu1_Value[TRI_Sync] != NONE)
             &&(PopMenu1_Value[TRI_Sync] != SCAN)){
            if(step!=0) PopMenu1_Value[index]-=step;
            else if(PopMenu1_Value[index]>limit) PopMenu1_Value[index]-=5;
          }
        }
        else if(PopMenu1_Value[index]>limit){
          if(step!=0) PopMenu1_Value[index]-=step;
          else        PopMenu1_Value[index]--;
        }else if(!PopMenu3_Value[SYS_ItemCyc]){
          if((index!=CH1_Vol)&&(index!=CH2_Vol)&&(index!=TIM_Base)) 
            PopMenu1_Value[index]=Popmenu1_Limit1[index];
        }
      }
      else{                                // indexΪThresholdʱ
        if(PopMenu1_Value[TRI_Ch]){        //triggerΪch2ǣӦֵ  
          if((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])>5+step){
            if(step!=0) PopMenu1_Value[TRI_Ch2]-=step;
            else        PopMenu1_Value[TRI_Ch2]--;
          }
        }
        else{
          if((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])>5+step){
            if(step!=0) PopMenu1_Value[TRI_Ch1]-=step;
            else        PopMenu1_Value[TRI_Ch1]--;
          }
        }         
      } 
    }
    if(index==CH1_Vol || index == CH2_Vol) Update[V1F] |= UPD ;  //V1-V2
    if(index==TIM_Base)                    Update[T1F] |= UPD ;
    break;
 //------------------------------ڶҳ˵----------------------------------//
 case Measure:
      j=menu.menu_index[menu.current];
      index=3*j+Cur_PopItem-1;               //popmenu2_base[j]
      if (mode==add){
        limit=PopMenu2_Limit1[Cur_PopItem-1];//-stepindex
        if(PopMenu2_Value[index]<limit)PopMenu2_Value[index]++;
        else{
          if(!PopMenu3_Value[SYS_ItemCyc]) 
            PopMenu2_Value[index]=PopMenu2_Limit2[index];
        }
      }
      else{
        limit=0;                             //PopMenu2_Limit2[index]+step;
        if(PopMenu2_Value[index]>limit)PopMenu2_Value[index]--;
        else{
          if(!PopMenu3_Value[SYS_ItemCyc]) 
            PopMenu2_Value[index]=PopMenu2_Limit1[index];
        }
      }
    break;
 //------------------------------ҳ˵----------------------------------//   
  case Option:
      item=menu.menu_index[menu.current];  
      index=PopMenu3_Base[item]+Cur_PopItem-1;
     
      if (mode==add){
        if(PopMenu3_Value[WAVE_Type]>0 && index==WAVE_Freq)
          limit=PopMenu3_Limit1[index]-step-5; 
        else limit=PopMenu3_Limit1[index]-step;
        if(PopMenu3_Value[index]<limit){
          if(step!=0) PopMenu3_Value[index]+=step;
          else        PopMenu3_Value[index]++;
        }
        else{
          if(!PopMenu3_Value[SYS_ItemCyc]) 
            PopMenu3_Value[index]=PopMenu3_Limit2[index];
        }
      }
      else{
        limit=PopMenu3_Limit2[index]+step;
        if(PopMenu3_Value[index]>limit){
          if(step!=0) PopMenu3_Value[index]-=step;
          else        PopMenu3_Value[index]--;
        }else{
          if(!PopMenu3_Value[SYS_ItemCyc]) 
            PopMenu3_Value[index]=PopMenu3_Limit1[index];
        }
      }
    break;
  }
  Show_PopMenu(Cur_PopItem);
  Update_Proc();
}
/*******************************************************************************
˵Ŀ
*******************************************************************************/
void Item_Proc(u8 mode)
{
  u16 j, index;
  menu.iflag|=UPD;  
  switch (menu.current){                  //˵ҳ
//------------------------------һҳ˵------------------------------------//  
  case Oscillo:
    j=menu.menu_index[menu.current];      //ǰ˵Ŀ
    index=PopMenu1_Base[j];               //ǰӴڵһ
    
    switch (j){    
    case TRIGGER: 
      index+=2;
    case CH1:       Update[V1F] |= UPD ;  //V1-V2
    case CH2:       Update[V1F] |= UPD ;  //V1-V2
    case TIMEBASE:  Update[T1F] |= UPD ;
      if(mode==add){
        if(PopMenu1_Value[index]<Popmenu1_Limit1[index])
          PopMenu1_Value[index]++;
        else if(!PopMenu3_Value[SYS_MenuCyc]){
          if((index!=CH1_Vol)&&(index!=CH2_Vol)&&(index!=TIM_Base))
          PopMenu1_Value[index] = PopMenu1_Limit2[index];
        }
      }
      else{
        if(PopMenu1_Value[index]>PopMenu1_Limit2[index])
          PopMenu1_Value[index]--;
        else if(!PopMenu3_Value[SYS_MenuCyc]){
          if((index!=CH1_Vol)&&(index!=CH2_Vol)&&(index!=TIM_Base))
          PopMenu1_Value[index] = Popmenu1_Limit1[index];
        }
      }
      break;  
    default:
      break;  
    }
    break;
//------------------------------ڶҳ˵------------------------------------//     
  case Measure:
    j=menu.menu_index[menu.current];        //ǰ˵Ŀ
    index = j*3+1;
    if(mode==add){
      if(PopMenu2_Value[index]<PopMenu2_Limit1[1])
        PopMenu2_Value[index]++;
      else if(!PopMenu3_Value[SYS_MenuCyc])
          PopMenu2_Value[index] = PopMenu2_Limit2[index];
    }
    else{
      if(PopMenu2_Value[index]>PopMenu2_Limit2[index])
        PopMenu2_Value[index]--;
      else if(!PopMenu3_Value[SYS_MenuCyc])
          PopMenu2_Value[index] = PopMenu2_Limit1[index];
    }    
    Show_Measure();                         //ˢʾ
    break;
 //------------------------------ҳ˵-----------------------------------//    
  case Option:
    break;
  default:
    break;
  }
  Update_Proc();                            //ˢµ
}

/*******************************************************************************
Ӳ˵ֱ
*******************************************************************************/
void Vertical_Slide(u8 mode)
{
  u16 j, index;
  
  switch (menu.current){                    //˵ҳ
//------------------------------һҳ˵------------------------------------//  
  case Oscillo:
    j=menu.menu_index[menu.current];       //ǰ˵Ŀ
    index=PopMenu1_Base[j]+1;              //ǰӴڵһ
    
    switch (j){    
    case TRIGGER: 
      index = (PopMenu1_Value[TRI_Ch])?TRI_Ch2:TRI_Ch1;
    case CH1:              
    case CH2:     
    case CH3:        
      if(mode==add){
        if(index==CH1_Posi){  
          if((PopMenu1_Value[CH1_Posi]<195)
             &&((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])>195)){
            PopMenu1_Value[TRI_Ch1]--;
            PopMenu1_Value[CH1_Posi]++;
          }else if(PopMenu1_Value[CH1_Posi]<Popmenu1_Limit1[index])
            PopMenu1_Value[CH1_Posi]++;
        }
        else if(index==CH2_Posi){
          if((PopMenu1_Value[CH2_Posi]<195)
             &&((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])>195)){
            PopMenu1_Value[TRI_Ch2]--;
            PopMenu1_Value[CH2_Posi]++;
          }else if(PopMenu1_Value[CH2_Posi]<Popmenu1_Limit1[index])
            PopMenu1_Value[CH2_Posi]++;
        }
        else if((index==TRI_Ch1)||(index==TRI_Ch2)){
          if(PopMenu1_Value[TRI_Ch]){    
            if((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])<195){
              PopMenu1_Value[TRI_Ch2]++;
            }
          }
          else{        
            if((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])<195){
              PopMenu1_Value[TRI_Ch1]++;
            }
          }
        }
        else{
          if(PopMenu1_Value[index]<Popmenu1_Limit1[index])
            PopMenu1_Value[index]++;
        }
      }
      //----dec mode----
      else{
        if(index==CH1_Posi){
          if((PopMenu1_Value[CH1_Posi]>5)
             &&((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])<5)){
            PopMenu1_Value[TRI_Ch1]++;
            PopMenu1_Value[CH1_Posi]--;
          }else if(PopMenu1_Value[CH1_Posi]>PopMenu1_Limit2[index])
            PopMenu1_Value[CH1_Posi]--;
        }
        else if(index==CH2_Posi){
          if((PopMenu1_Value[CH2_Posi]>5)
             &&((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])<5)){
            PopMenu1_Value[TRI_Ch2]++;
            PopMenu1_Value[CH2_Posi]--;
          }else if(PopMenu1_Value[CH2_Posi]>PopMenu1_Limit2[index])
            PopMenu1_Value[CH2_Posi]--;
        } 
        else if((index==TRI_Ch1)||(index==TRI_Ch2)){
          if(PopMenu1_Value[TRI_Ch]){         
            if((PopMenu1_Value[TRI_Ch2]+PopMenu1_Value[CH2_Posi])>5){
              PopMenu1_Value[TRI_Ch2]--;
            }
          }
          else{
            if((PopMenu1_Value[TRI_Ch1]+PopMenu1_Value[CH1_Posi])>5){
              PopMenu1_Value[TRI_Ch1]--;
            }
          } 
        }
        else{
          if(PopMenu1_Value[index]>PopMenu1_Limit2[index])
            PopMenu1_Value[index]--;
        }
      }
      
      Update_Proc_All();
      Label_Flag  |= UPD;
      Update_Label();
      Beep(50); 
      
      break;  
    default:
      break;  
    }
    break;
  default:
    break;
  }
}

/*******************************************************************************
һӦ´ 
*******************************************************************************/
void Update_Proc(void)
{
  s16 j,k,l,index;
  if(Windows_Pop==0){
    menu.iflag|=UPD;
    Label_Flag|=UPD;
  }
  switch (menu.current){
//------------------------------һҳ˵------------------------------------//
  case Oscillo:
    j=menu.menu_index[menu.current];
    index=PopMenu1_Base[j];
    switch (j){
    case CH1:  
      if((Status != STOP)){
      StateA = PopMenu1_Value[CH1_Enable]? GND : ACT ;  //Ch1ӵػ򼤻״̬ 
      GainA  = PopMenu1_Value[CH1_Vol]%5;               //
      KindA  = PopMenu1_Value[CH1_Vol]/5;               //Ch1ѡѹѹ
      CouplA = ((PopMenu1_Value[CH1_Coupl])? DC : AC);  //AC/DCϷʽ
      __Ctrl(AiRANGE, KindA+CouplA+StateA);             //Ch1״̬ˢ
      }
      ParamTab[P1x2]=2*(PopMenu1_Value[CH1_Posi]);      //Ch1αλ 
      ParamTab[W1F]=PopMenu1_Value[CH1_Enable]? B_HID : L_HID;  //Ch1 show_hide 
      AiPosi(PopMenu1_Value[CH1_Posi]);                 //Ch1ӲӦλ
      k=(PopMenu1_Value[TRI_Ch])?PopMenu1_Value[TRI_Ch2]:PopMenu1_Value[TRI_Ch1];
      l=(PopMenu1_Value[TRI_Ch])?ParamTab[P2x2]:ParamTab[P1x2]; 
      ParamTab[VTx2]=l+2*k;
      ParamTab[VTC]=CH_Col[PopMenu1_Value[TRI_Ch]];
      ParamTab[VTF]=(PopMenu1_Value[TRI_Enable])? L_HID : W_HID;
      if(Cur_PopItem==2)Update[W1F]|=UPD;               //αˢ±־
      break;
    case CH2:
      if((Status != STOP)){
      StateB = PopMenu1_Value[CH2_Enable]? GND : ACT ;  //Ch2ӵػ򼤻״̬  
      GainB  = PopMenu1_Value[CH2_Vol]%5; 
      KindB  = PopMenu1_Value[CH2_Vol]/5;
      CouplB = ((PopMenu1_Value[CH2_Coupl])? DC : AC);
      __Ctrl(BiRANGE, KindB+CouplB+StateB);
      }
      ParamTab[P2x2]=2*(PopMenu1_Value[CH2_Posi]);
      ParamTab[W2F]=PopMenu1_Value[CH2_Enable]? B_HID : L_HID;
      BiPosi(PopMenu1_Value[CH2_Posi]);
      k=(PopMenu1_Value[TRI_Ch])?PopMenu1_Value[TRI_Ch2]:PopMenu1_Value[TRI_Ch1];
      l=(PopMenu1_Value[TRI_Ch])?ParamTab[P2x2]:ParamTab[P1x2]; 
      ParamTab[VTx2]=l+2*k;
      ParamTab[VTC]=CH_Col[PopMenu1_Value[TRI_Ch]];
      ParamTab[VTF]=(PopMenu1_Value[TRI_Enable])? L_HID : W_HID;
      if(Cur_PopItem==2)Update[W2F]|=UPD;
      break;
    case CH3:
      ParamTab[W3F]=PopMenu1_Value[CH3_Enable]? B_HID : L_HID;
      ParamTab[P3x2]=2*(PopMenu1_Value[CH3_Posi]);
      if(Cur_PopItem==2)Update[W3F]|=UPD;
      break;
    case TIMEBASE:
      Set_Base(PopMenu1_Value[TIM_Base]);              //Ӳɨʱλ
      break;
    case TRIGGER:
      k=(PopMenu1_Value[TRI_Ch])?PopMenu1_Value[TRI_Ch2]:PopMenu1_Value[TRI_Ch1];
      l=(PopMenu1_Value[TRI_Ch])?ParamTab[P2x2]:ParamTab[P1x2]; 
      ParamTab[VTx2]=l+2*k;
      ParamTab[VTC]=CH_Col[PopMenu1_Value[TRI_Ch]];
      ParamTab[VTF]=(PopMenu1_Value[TRI_Enable])? L_HID : W_HID;
      break;
    case COURSOR:
      ParamTab[T1x1]=PopMenu1_Value[CUR_T1]+1;
      ParamTab[T2x1]=PopMenu1_Value[CUR_T2]+1;
      if(PopMenu1_Value[CUR_T]==0)
        ParamTab[T1F]=SHOW;
      else ParamTab[T1F]=L_HID;
      ParamTab[T2F]=ParamTab[T1F];
      ParamTab[V1x2]=2*(PopMenu1_Value[CUR_V1]+1);   
      ParamTab[V2x2]=2*(PopMenu1_Value[CUR_V2]+1);    
      if(PopMenu1_Value[CUR_V]==2)                     // CH1,Ch2,OFF
        ParamTab[V1F]=L_HID;
      else ParamTab[V1F]=SHOW;
      ParamTab[V2F]=ParamTab[V1F];
      if(Cur_PopItem==4)Update[V1F]|=UPD;
      if(Cur_PopItem==5)Update[V2F]|=UPD;
      if(Cur_PopItem==1)Update[T1F]|=UPD;
      if(Cur_PopItem==2)Update[T2F]|=UPD;
      if(Cur_PopItem==6)Update[V1F]|=UPD ;            //V1-V2
      break;
    case WINDOWS:
      index++;
      switch(PopMenu1_Value[WIN_T0]){
        case 0:
          ParamTab[T0x1]= 125 - PopMenu1_Value[WIN_Posi];
          if(Cur_PopItem==4 || Cur_PopItem==2){
            T0_PerCnt =  PRE_SMPL;} 
          break;
        case 1:
          ParamTab[T0x1]= Depth/2+125 - PopMenu1_Value[WIN_Posi];
          if(Cur_PopItem==4 || Cur_PopItem==2){T0_PerCnt =  Depth/2 - PRE_SMPL;}
          break;
        case 2:
          ParamTab[T0x1]= Depth-125 - PopMenu1_Value[WIN_Posi];
          if(Cur_PopItem==4 || Cur_PopItem==2){T0_PerCnt =  Depth - PRE_SMPL ;}
          break;  
        }
      ParamTab[T0F] =PopMenu1_Value[WIN_Enable];
      if(Status != STOP)ADC_Start();                    //¿ʼADCɨ
      break;
    default:
      break;
    }
    break;
//------------------------------ڶҳ˵------------------------------------//   
  case Measure:
    j=menu.menu_index[menu.current];
    switch(j){
    case MEA_1:
      break;
    }
    break;
//------------------------------ҳ˵------------------------------------//    
  case Option: 
    j= 7+6+menu.menu_index[menu.current];
    index=PopMenu3_Base[menu.menu_index[menu.current]];
    switch(j){
    case FILE: 
      break;
    case WAVE:      
      if(Cur_PopItem==1){                                    //ѡ
        if(PopMenu3_Value[WAVE_Type]==0){                    //
          __Ctrl(OUT_PSC, FPSC[PopMenu3_Value[WAVE_Freq]]);  // 72MHz/72 = 1MHz 
          __Ctrl(OUT_ARR, FARR[PopMenu3_Value[WAVE_Freq]]);  // 1MHz/100 = 10KHz 
          __Ctrl(OUT_WTH, FARR[PopMenu3_Value[WAVE_Freq]]*PopMenu3_Value[WAVE_Duty]/10); 
          __Ctrl(OUT_MOD, PULSED);                           // 趨ģʽ
        }
        else{                                         //ģⲨ
         if(PopMenu3_Value[WAVE_Freq] > MAX_FREQ){    //ģⲨ20KHz
             PopMenu3_Value[WAVE_Freq] = MAX_FREQ ;   //20KHz
          }
          __Ctrl(OUT_MOD, DISABLE);
          if(PopMenu3_Value[WAVE_Freq] > 8){
            __Ctrl(OUT_CNT, 36);
            TIM_DA->PSC = Dac_Psc[PopMenu3_Value[WAVE_Freq]] - 1;
            __Ctrl(DAC_TIM, Dac_Tim[PopMenu3_Value[WAVE_Freq]]);  
            __Ctrl(OUT_BUF, WaveOut_Date(PopMenu3_Value[WAVE_Type]));
          }
          else{
            __Ctrl(OUT_CNT, 180);       
            TIM_DA->PSC = Dac_Psc[PopMenu3_Value[WAVE_Freq]] - 1;
            __Ctrl(DAC_TIM, Dac_Tim[PopMenu3_Value[WAVE_Freq]]);  
            __Ctrl(OUT_BUF, __Info(22+PopMenu3_Value[WAVE_Type]));
          }
          __Ctrl(OUT_MOD, ANALOG);
          PopMenu3_Value[WAVE_Duty] = 5; //Duty =50% 
          Show_PopMenu(Cur_PopItem);     //βΪʱDutyˢΪ50%   
        }
      }
      if(Cur_PopItem==2){
        if(PopMenu3_Value[WAVE_Type]==0){
          __Ctrl(OUT_PSC, FPSC[PopMenu3_Value[WAVE_Freq]]);  // 72MHz/72 = 1MHz  
          __Ctrl(OUT_ARR, FARR[PopMenu3_Value[WAVE_Freq]]);  // 1MHz/100 = 10KHz 
          __Ctrl(OUT_WTH, FARR[PopMenu3_Value[WAVE_Freq]]*PopMenu3_Value[WAVE_Duty]/10);   
        }
        else{
          if(PopMenu3_Value[WAVE_Freq] > MAX_FREQ){         
             PopMenu3_Value[WAVE_Freq] = MAX_FREQ ;         
          }
          __Ctrl(OUT_MOD, DISABLE);
          if(PopMenu3_Value[WAVE_Freq] > 8){
            __Ctrl(OUT_CNT, 36);
            TIM_DA->PSC = Dac_Psc[PopMenu3_Value[WAVE_Freq]] - 1;
            __Ctrl(DAC_TIM, Dac_Tim[PopMenu3_Value[WAVE_Freq]]);     
            __Ctrl(OUT_BUF, WaveOut_Date(PopMenu3_Value[WAVE_Type])); 
          }
          else{
            __Ctrl(OUT_CNT, 180);                 // ģ(ÿ180)
            TIM_DA->PSC = Dac_Psc[PopMenu3_Value[WAVE_Freq]] - 1;
            __Ctrl(DAC_TIM, Dac_Tim[PopMenu3_Value[WAVE_Freq]]);  
            __Ctrl(OUT_BUF, __Info(22+PopMenu3_Value[WAVE_Type]));    
          }
          __Ctrl(OUT_MOD, ANALOG);
          PopMenu3_Value[WAVE_Duty] = 5;   //Duty =50% 
          Show_PopMenu(Cur_PopItem);      //βΪʱDutyˢΪ50% 
        }
      }
      if(Cur_PopItem==3){
        if(PopMenu3_Value[WAVE_Type]==0){
          __Ctrl(OUT_WTH, FARR[PopMenu3_Value[WAVE_Freq]]*PopMenu3_Value[WAVE_Duty]/10); 
        }
      }
      break;
    case SYSTEM:
      if(Cur_PopItem==1){
        __Ctrl(BUZZVOL, PopMenu3_Value[SYS_Volume]*10);                 
        Beep(100);}
      if(Cur_PopItem==2)__Ctrl(B_LIGHT, PopMenu3_Value[SYS_BKLight]*10);
      if(Cur_PopItem==3)PD_Cnt = PopMenu3_Value[SYS_Standy]*Unit;
      if(Cur_PopItem==4)AutoPwr_Cnt = PopMenu3_Value[SYS_PowerOff]*Unit;
      
      break;
    case CALIBRATION:
      break;
    case PRO:
      break;
    case ABOUT:
      break;  
    }
    break;  
  }  
}  
/*******************************************************************************
ʾ˵ 
*******************************************************************************/
void PMenu_Pop(u8 item,u8 current,u8* str1, u8 str_num, u8* str2)
{
  u8  Wink, i, j;
  u16 Px,Py;
  u8* ptr1,*ptr2;
  j=menu.menu_index[menu.current];
  item=Cur_Limit;
  PopColor(WHT, DAR); 
  PopType |= LIST_POP;
  OpenPop(PopMenu1_Posi_X[j], PopMenu1_Posi_Y[j], (item)*12+12,  16*6+2, COVER);
  ptr1=str1;
  ptr2=str2;
  Wink = INV;
   
  PopColor(WHT, DAR);
  for(i = 1; i <= item; i++){
    Px = 4;
    Py = 4+13*(item-i);
    if(i==current){
      Wink = INV;}
    else  {
      Wink = PRN;
    }
    Pop_STR6x8(Px, Py, Wink, ptr1);
    Px = 4+str_num*6;   
    Pop_STR6x8(Px, Py, Wink, ptr2);
    ptr1+=13;
    ptr2+=9;    
  }
  PopCnt = 5000;        
}
/*******************************************************************************
ļ˵ 
*******************************************************************************/
void FMenu_Pop(u8 item,u8 current,u8* str1)
{
  u8  Wink, i, j;
  u16 Px,Py;
  u8* ptr1;
  j=menu.menu_index[menu.current];
  item=Cur_Limit;
  PopColor(WHT, DAR); 
  PopType |= FILE_POP;
  OpenPop(PopMenu3_Posi_X[j], PopMenu1_Posi_Y[j],(item)*16+4,  14*6,  COVER); 
  ptr1=str1;
  Wink = INV;
  for(i = 1; i <= item; i++){
    Px = 6;
    Py = 4+16*(item-i);
    if(i==current)Wink = INV;
    else  Wink = PRN;
    Pop_STR6x8(Px, Py, Wink, ptr1);
    Px = 6+5*6;
    if(i>1)
    {
      sprintf((char*)NumStr,"%02d",
              PopMenu3_Value[PopMenu3_Base[menu.menu_index[menu.current]]+i-1]);   
      Pop_STR6x8(Px, Py, Wink, NumStr);
    }
    ptr1+=13;   
  }
  PopCnt = 5000;        
}

/*******************************************************************************
˵ر־ 
*******************************************************************************/
void Menu_Hide(void)
{
  u16 x, y, i, j, high, Width, col;
  col = WHT;
  high = 50; Width = 8;
  x = 313; y = 50;
  
  SetPosi(x,y+2);
  for(j=0;j<high-4;j++)SetPixel(col);
  SetPosi(x+1,y+1);
  for(j=0;j<high-2;j++)SetPixel(col);
  for(i=0;i<Width;i++){ 
    SetPosi(x+2,y); x++;
    for(j=0;j<high;j++)SetPixel(col); 
  } 
}
/*******************************************************************************
 Update_Label: αλʾ
*******************************************************************************/
void Update_Label(void)
{
  s16 x,y;
  u16 i,j;
  if(!(Label_Flag & UPD))return;
  Windows_Pop=0;
  Label_Flag &=~ UPD;
  x=0;y=19;   //
  for(i=0;i<7;i++){
    SetPosi(x++, y);
    for(j=0; j<204; j++)SetPixel(DAR);//
  }  
 //--------tmep process-------------------------------//  
  if(((Update[VTF] & UPD)==UPD) ){
    Sx = 0;
    Sy =ParamTab[VTx2]/2+16;
    SetColor(DAR, ParamTab[VTC]);
    PrintStr_Cur(SYMB,"4"); //T
  }
  if(((Update[W1F] & UPD)==UPD)){
    Sx = 0;
    Sy =ParamTab[P1x2]/2+16;  
    SetColor(DAR,ParamTab[W1C]);//
    PrintStr_Cur(SYMB,"1"); //1
  }
  if(((Update[W2F] & UPD)==UPD) ){
    Sx = 0;
    Sy =ParamTab[P2x2]/2+16;  
    SetColor(DAR, ParamTab[W2C]);
    PrintStr_Cur(SYMB,"2");//2
  }
  if(((Update[W3F] & UPD)==UPD) ){
    Sx = 0;
    Sy =ParamTab[P3x2]/2+16;  
    SetColor(DAR, ParamTab[W3C]);
    PrintStr_Cur(SYMB,"3");//3
  } 
  if((((Update[T1F] & UPD)==UPD) )&& (ParamTab[T1F]==SHOW)){
    SetColor(DAR, ORN);
    Print_dT_Info(INV);
    Update[T1F] &=~ UPD ;
  }
   if((((Update[T2F] & UPD)==UPD) )&& (ParamTab[T2F]==SHOW)){
    SetColor(DAR, ORN);
    Print_dT_Info(INV);
    Update[T2F] &=~ UPD ;
  }  
  if(((Update[V1F] & UPD)==UPD) &&(ParamTab[V1F]==SHOW)){
    Sx = 0;
    Sy =ParamTab[V1x2]/2+13;  
    SetColor(DAR, CYN);
    Print_dV_Info(INV); 
    Sx=12*8;   
    Update[V1F] &=~ UPD ;
  }
  if(((Update[V2F] & UPD)==UPD) &&(ParamTab[V2F]==SHOW)){
    Sx = 0;
    Sy =ParamTab[V2x2]/2+13;  
    SetColor(DAR, CYN);
    Print_dV_Info(INV); 
    Sx=12*8; 
    Update[V2F] &=~ UPD ;
  }
    //NORMûʱ׶˲ֵ
  if((PopMenu1_Value[TRI_Sync] == NORM)&&(Trigger_k < 0));  
  else{
    Print_dM_Info(INV, 0, 12*6+5 , TITLE_L);
    Print_dM_Info(INV, 1, 12*6+14*6+10 , TITLE_L);
  }
 
}

/*******************************************************************************
Сͣ״̬ 
*******************************************************************************/
void Update_Status(void)
{
  u8  index;
  Sx = Title_Posi_X[6];
  Sy=TITLE_H+2;
  
  if(Status==STOP){
    Draw_Circle_D(RED, Title_Posi_X[6]-3, TITLE_H+2, 11, 2, 5*6-1);//ǰ߿
    SetColor(DAR,RED);
    PrintStr6x8(INV,(u8*)&Mode[5] );
  }
  else{
    Draw_Circle_D(GRN, Title_Posi_X[6]-3, TITLE_H+2, 11, 2, 5*6-1);//ǰ߿
    index=PopMenu1_Base[TRIGGER];
    SetColor(DAR,GRN);
    PrintStr6x8(INV,(u8*)&Mode[PopMenu1_Value[index]] );//"AUTO"
  }
}
/*******************************************************************************
»λ 
*******************************************************************************/
void Update_Windows(void)
{
  u16  x0,x,y,i,j,Width;
  Depth =  DEPTH[PopMenu1_Value[WIN_Depth]];
  Width =(215*300)/Depth;
  if(menu.menu_index[menu.current]==6 && Cur_PopItem==2){  //Depthѡ
    if(KeyIn == K_RIGHT || KeyIn == K_LEFT){  //ѡб䶯ʱıԤλ
      switch(PopMenu1_Value[WIN_T0]){
      case 0:
        PopMenu1_Value[WIN_Posi]= 0;
        x0=10+(PopMenu1_Value[WIN_Posi])*250/Depth;
        break;
      case 1:
        PopMenu1_Value[WIN_Posi]= Depth/2;
        x0=10+(Depth/2-125)*247/Depth;
        break;
      case 2:
        PopMenu1_Value[WIN_Posi]= Depth-300-5; //-5 
        x0=10+(Depth-300-5)*250/Depth;
        break;
      }
    }
  }
  if( PopMenu1_Value[WIN_T0]==0){
    if(menu.menu_index[menu.current]==6 && Cur_PopItem==4){
      if(KeyIn == K_RIGHT || KeyIn == K_LEFT)
      PopMenu1_Value[WIN_Posi]= 0;
      x0=10+(PopMenu1_Value[WIN_Posi])*250/Depth;
    }
    else x0=10+(PopMenu1_Value[WIN_Posi])*250/Depth;	
  }
  else if( PopMenu1_Value[WIN_T0]==1){
    if(menu.menu_index[menu.current]==6 && Cur_PopItem==4){
      if(KeyIn == K_RIGHT || KeyIn == K_LEFT)
        PopMenu1_Value[WIN_Posi]= Depth/2;
      x0=10+(Depth/2-125)*247/Depth;
    }
    else x0=10+(Depth/2-125+(PopMenu1_Value[WIN_Posi]-Depth/2))*247/Depth;	
  }
  else if( PopMenu1_Value[WIN_T0]==2){
    if(menu.menu_index[menu.current]==6 && Cur_PopItem==4){
      if(KeyIn == K_RIGHT || KeyIn == K_LEFT)
        PopMenu1_Value[WIN_Posi]= Depth-300-5;//-5 
      x0=10+(Depth-300-5)*250/Depth;
    }
    else x0=10+(PopMenu1_Value[WIN_Posi])*250/Depth;
  }
  if(Windows_Flag & UPD){  //ˢ´
    Windows_Flag&=~UPD;
    x=10;
    y=15;
    for(i=0;i<250;i++){    //
      SetPosi(x++, y);
      SetPixel(DAR);
      for(j=0; j<2; j++)SetPixel(RED);
      SetPixel(DAR);     
    }
    x = x0;               //ǰڻλ
    y=15;   
    for(i=0;i<Width;i++){
      SetPosi(x++, y);
      for(j=0; j<4; j++)SetPixel(GRN);
    }
  }
  else if(Windows_Flag == 0){    //С
    Clr_WavePosi(DAR);
  }
}
/*******************************************************************************

*******************************************************************************/
void MeasureStr(u8 Source, u8 Item)
{
  u16 Dpth;
  s32 scale;
  s64 Temp;
  u64 FTmp;
  s32 Ak = (KgA[KindA]*4)/GK[GainA+5*KindA];
  s32 Bk = (KgB[KindB]*4)/GK[GainB+5*KindB]; // 8192~409
  
  if(((PopMenu1_Value[TRI_Sync] == NONE)||(PopMenu1_Value[TRI_Sync] == SCAN))
     &&(PopMenu1_Value[TIM_Base]>11)){
    Dpth = 302;
  }else Dpth = DEPTH[PopMenu1_Value[WIN_Depth]];
  
  switch (Item){
  case 0: // Freq  Ϊ
    if(Source == CH1)FTmp=EdgeA*25*1000/2;
    else             FTmp=EdgeB*25*1000/2;
    if(PopMenu1_Value[TIM_Base]<9)FTmp= FTmp*1000000;
    else if(PopMenu1_Value[TIM_Base]<18)FTmp= FTmp*1000;
    FTmp=FTmp/Ts[PopMenu1_Value[TIM_Base]]/Dpth;
    if(PopMenu1_Value[TIM_Base]<2) Temp=2*FTmp; //ģʽ Depth/2 *2
    else Temp=FTmp;
    Value2Str(NumStr, Temp, (u8*)FSTR, 3, UNSIGN); break;
  case 1: // Duty
    if(Source == CH1)Temp = (HighA*100)/(HighA + LowA);
    else             Temp = (HighB*100)/(HighB + LowB);
    Value2Str(NumStr, Temp, (u8*)PCNT, 2, UNSIGN); break;
  case 2: // Vrms 
    if(Source == CH1){
      scale = VScale[PopMenu1_Value[CH1_Vol]]*40;
      Temp  = ((((PrmsA)*Ak)>>12))*scale;
    }else{
      scale = VScale[PopMenu1_Value[CH2_Vol]]*40;
      Temp  = ((((PrmsB)*Bk)>>12))*scale;
    }
    if(fabs(Temp)<(scale*25*10/100)){
      Temp=0;
      //ֵСѡλ10%ʱʾλ
      Value2Str(NumStr, Temp, (u8*)NSTR, 3, SIGN); } 
    else Value2Str(NumStr, Temp, (u8*)YSTR, 3, SIGN); 
    break;
  case 3: // Vavg
    if(Source == CH1){
      scale = VScale[PopMenu1_Value[CH1_Vol]]*40;
      Temp  = ((((PavgA-2048)*((KgA[KindA]*4)/GK[GainA+5*KindA]))>>12)
               +100-PopMenu1_Value[CH1_Posi])*scale;
    }else{
      scale = VScale[PopMenu1_Value[CH2_Vol]]*40;
      Temp  = ((((PavgB-2048)*((KgB[KindB]*4)/GK[GainB+5*KindB]))>>12)
               +100-PopMenu1_Value[CH2_Posi])*scale;
    }
    if(fabs(Temp)<(scale*25*10/100)){
      Temp=0;
      Value2Str(NumStr, Temp, (u8*)NSTR, 3, SIGN);} 
    else Value2Str(NumStr, Temp, (u8*)YSTR, 3, SIGN); 
    break;
  case 4: // Vp-p
    if(Source == CH1){
      scale = VScale[PopMenu1_Value[CH1_Vol]]*40;
      Temp  = ((((PmaxA-2048)*((KgA[KindA]*4)/GK[GainA+5*KindA]))>>12)
               -(((PminA-2048)*((KgA[KindA]*4)/GK[GainA+5*KindA]))>>12))*scale;
    }else{
      scale = VScale[PopMenu1_Value[CH2_Vol]]*40;
      Temp  = ((((PmaxB-2048)*((KgB[KindB]*4)/GK[GainB+5*KindB]))>>12)
               -(((PminB-2048)*((KgB[KindB]*4)/GK[GainB+5*KindB]))>>12))*scale;
    }
    if(fabs(Temp)<(scale*25*20/100)){
      Temp=0;
      Value2Str(NumStr, Temp, (u8*)NSTR, 3, SIGN);} 
    else Value2Str(NumStr, Temp, (u8*)YSTR, 3, SIGN); 
    break;
  case 5: // Vmax
    if(Source == CH1){
      scale = VScale[PopMenu1_Value[CH1_Vol]]*40;
      Temp  = ((((PmaxA-2048)*((KgA[KindA]*4)/GK[GainA+5*KindA]))>>12)
               +100-PopMenu1_Value[CH1_Posi])*scale;
    }else{
      scale = VScale[PopMenu1_Value[CH2_Vol]]*40;
      Temp  = ((((PmaxB-2048)*((KgB[KindB]*4)/GK[GainB+5*KindB]))>>12)
               +100-PopMenu1_Value[CH2_Posi])*scale;
    }
    if(fabs(Temp)<(scale*25*10/100)){
      Temp=0;
      Value2Str(NumStr, Temp, (u8*)NSTR, 3, SIGN);}
    else Value2Str(NumStr, Temp, (u8*)YSTR, 3, SIGN);
    break;
  case 6: // Vmin
    if(Source == CH1){
      scale = VScale[PopMenu1_Value[CH1_Vol]]*40;
      Temp  = ((((PminA-2048)*((KgA[KindA]*4)/GK[GainA+5*KindA]))>>12)
               +100-PopMenu1_Value[CH1_Posi])*scale;
    }else{
      scale = VScale[PopMenu1_Value[CH2_Vol]]*40;
      Temp  = ((((PminB-2048)*((KgB[KindB]*4)/GK[GainB+5*KindB]))>>12)
               +100-PopMenu1_Value[CH2_Posi])*scale;
    }
    if(fabs(Temp)<(scale*25*10/100)){
      Temp=0;
      Value2Str(NumStr, Temp, (u8*)NSTR, 3, SIGN);}
    else Value2Str(NumStr, Temp, (u8*)YSTR, 3, SIGN);
    break;
  case 7: // Vbty
    Temp =  Vbat*1000;
    Value2Str(NumStr, Temp, (u8*)YSTR, 3, UNSIGN); break;
  }  
}
/*******************************************************************************
ص
*******************************************************************************/
void Battery_update(void)
{
  u8 str[5];
  SetColor(DAR, BT_C[Battery]);
  memcpy(&str[0],&BT_S[Battery],4);   
  Draw_Circle_D(Foreground, Title_Posi_X[0]-3, TITLE_H+2, 11, 2, 4*6-2);
  DispStr6x8(Title_Posi_X[0], TITLE_H+2, INV+SYMB, str);
}
/*******************************************************************************
صʾ
*******************************************************************************/
void Battery_Show(void)
{
  SetColor(DAR, GRN);  
  Draw_Circle_D(Foreground, Title_Posi_X[0]-3, TITLE_H+2, 11, 2, 4*6-2);
  DispStr6x8(Title_Posi_X[0], TITLE_H+2, INV+SYMB, ";*@");           //ذ
}
/*******************************************************************************
  ʾʾ
*******************************************************************************/
void Param_Pop(u8* str)
{
  u16 Px,Py;
  PopColor(DAR, WHT);
  PopType &=~(MENU_POP|LIST_POP);
  PopType |= DAILOG_POP;           //LIST_POP;PWR_POP;
  OpenPop(80, 80, 40, 144,COVER);
  Px =8; Py = 23;
  Pop_STR6x8(Px,Py,PRN,str );      //"Save Parameter ?"
  Px=3*6; Py = 5;
  Pop_STR6x8(Px,Py,INV, " Yes "); 
  Px=11*6;Py = 5;
  Pop_STR(Px,Py,INV, " No "); 
}
/*******************************************************************************
 T1-T2Ĳֵ
*******************************************************************************/
void Print_dT_Info(u8 Wink)
{
  s32  Tmp,scale; 
  scale=TScale[PopMenu1_Value[TIM_Base]];
  Tmp =scale *(ParamTab[T2x1]-ParamTab[T1x1])/25;
  Value2Str(NumStr, Tmp, (u8*)XSTR, 3, SIGN);
  Sx=0;
  Sy=0;
  SetColor(DAR, ORN);  
  Draw_Circle_D(ORN, 255-3, TITLE_L, 11, 2, 11*6-2);
  DispStr6x8(255, TITLE_L, INV, "          ");
  DispStr6x8(255, TITLE_L, INV+SYMB, "]T:");
  DispStr6x8(270, TITLE_L, Wink, NumStr);
}
/*******************************************************************************
 V1-V2Ĳֵ
*******************************************************************************/
void Print_dV_Info(u8 Wink)
{
  s32  Tmp,scale;
  u8 index;
  index=(PopMenu1_Value[CUR_V])?PopMenu1_Value[CH2_Vol]:PopMenu1_Value[CH1_Vol];
  scale=VScale[index];
  Tmp =scale *((ParamTab[V1x2]-ParamTab[V2x2])/2)/25;
  Value2Str(NumStr, Tmp, (u8*)&YSTR[1], 3, SIGN);
  Sx=0,Sy=0;
  SetColor(Background, CH_Col[PopMenu1_Value[CUR_V]]); 
  Draw_Circle_D(CH_Col[PopMenu1_Value[CUR_V]], 1*6-3, TITLE_L, 11, 2, 11*6-2);
  DispStr6x8(6,   TITLE_L, INV, "          ");
  DispStr6x8(1*6, TITLE_L, INV+SYMB, "]V:");
  DispStr6x8(4*6, TITLE_L, Wink, NumStr);
}
/*******************************************************************************
ʾֵ
*******************************************************************************/
void Print_dM_Info(u8 Wink , u8  Num, u16 Posi_x, u16 Posi_y)
{
  u8  type,source;
  u8* ptr;
  source = PopMenu2_Value[3*Num];
  type=PopMenu2_Value[3*Num+1];
  ptr=(u8*)&MeasStr[type];   
  MeasureStr(source,type);
  SetColor(Background,CH_Col[source]);
  Sx=Posi_x,Sy=Posi_y;   
  Draw_Circle_D(CH_Col[source], Posi_x-3, Posi_y, 11, 2, 14*6-2);
  DispStr6x8(Posi_x,     Posi_y, Wink, ptr);
  DispStr6x8(Posi_x+5*6, Posi_y, Wink, "        ");
  DispStr6x8(Posi_x+5*6, Posi_y, Wink, NumStr);
}
/*******************************************************************************
ļ洢ʾ
*******************************************************************************/
void DispFileInfo(u8 Info)
{ 
  SetColor(DAR, RED);
  DispStr(252, TITLE_L-1, PRN, "             ");
  DispStr6x8(252, TITLE_L, PRN, ((u8*)&FnNote+14*Info));
  __Ctrl(DELAYmS, 1000);
  DispStr(252, TITLE_L-1, PRN, "             ");
}
/*******************************************************************************
ĿԲǿ
*******************************************************************************/
void Draw_Circle_S(u16 Col, u16 Posi_x, u16 Posi_y, u16 High, u16 Width)
{
  u16 x,y,i,j;
  x=Posi_x;
  y=Posi_y;
  SetPosi(x, y);
  SetPixel(DAR);SetPixel(DAR);
  for(j=0;j<High-4;j++)SetPixel(Col);
  SetPixel(DAR);SetPixel(DAR);
  x=Posi_x+1;SetPosi(x, y);
  SetPixel(DAR);      
  for(j=0;j<High-2;j++)SetPixel(Col);
  SetPixel(DAR); 
  x=Posi_x+2; y=Posi_y; SetPosi(x, y);      
  for(i=0;i<Width;i++){
    SetPosi(x++, y);
    for(j=0; j<High; j++)SetPixel(Col);
  }
}
/*******************************************************************************
Ŀ˫Բǿ
*******************************************************************************/
void Draw_Circle_D(u16 Col, u16 Posi_x, u16 Posi_y, u16 High, u16 Width, u16 Distance)
{
  u16 x, y, i, j;
  
  x = Posi_x;
  y = Posi_y + 2;            
  SetPosi(x, y);
  for(j=0;j<High-4;j++ )SetPixel(Col);
  x = Posi_x + Distance;
  SetPosi(x, y);
  for(j=0;j<High-4;j++ )SetPixel(Col);
  x = Posi_x + 1;
  y = Posi_y + 1;
  SetPosi(x, y);
  for(j=0;j<High-2;j++ )SetPixel(Col);
  x = Posi_x + Distance-1;
  SetPosi(x, y);
  for(j=0;j<High-2;j++ )SetPixel(Col);
  x = Posi_x + Distance-2;
  y = Posi_y;
  SetPosi(x, y);
  for(j=0;j<High;j++ )SetPixel(Col);
  x = Posi_x + 2;
  y = Posi_y;
  for(i=0;i<Width;i++){
    SetPosi(x++, y);
    for(j=0; j<High; j++)SetPixel(Col);
  }
}
/*******************************************************************************

*******************************************************************************/
void Draw_Rectangle(u16 Col, u16 Posi_x, u16 Posi_y, u16 High, u16 width)
{
  u16 x,y,i,j;
  x=Posi_x;
  y=Posi_y;
  SetPosi(x, y);     
  for(i=0;i<width;i++){
    SetPosi(x++, y);
    for(j=0; j<High; j++)SetPixel(Col);
  }
}
/*******************************************************************************
վ
*******************************************************************************/
void Draw_RECT(u16 Col, u16 Posi_x, u16 Posi_y, u16 High, u16 width, u8 R )
{
  u16 x,y,i,j;
  x=Posi_x;
  y=Posi_y;
  SetPosi(x, y);     
  for(i=0;i<R;i++){
    SetPosi(x++, y);
    for(j=0; j<High; j++)SetPixel(Col);
  }
  SetPosi(Posi_x+R, y);
  for(i=0;i<width-2*R;i++){
    SetPosi(x, y);
    for(j=0; j<R; j++)SetPixel(Col);
    SetPosi(x++, y+High-R);
    for(j=0; j<R; j++)SetPixel(Col);
  }
  x=Posi_x+width-R;
  SetPosi(x, y); 
  for(i=0;i<R;i++){
    SetPosi(x++, y);
    for(j=0; j<High; j++)SetPixel(Col);
  }
}

/*******************************************************************************

*******************************************************************************/
void Clear_Label_R(u16 Col)
{
    u16 x, y ,i, j;  
    x = Menu_X-2;
    y = 20; 
    for(i=0;i<59;i++){
      SetPosi(x++, y);
      for(j=0; j<204; j++)SetPixel(Col);
    }
}
/*******************************************************************************

*******************************************************************************/
void Clear_Label_L(u16 Col)
{
    u16 x, y ,i, j;  
    x=0;y=19;  
    for(i=0;i<7;i++){
      SetPosi(x++, y);
      for(j=0; j<204; j++)SetPixel(Col);
    } 
  }
/*******************************************************************************

*******************************************************************************/
u32 WaveOut_Date(u16 type)
{
  switch (type){
  case 1:
    return (u32)SIN_DATA; break;
  case 2:
    return (u32)TRG_DATA; break;
  case 3:
    return (u32)SAW_DATA; break;
  default:     
    return 0; 
  }
}
/*******************************************************************************
Update_Proc_All  ȫˢ
*******************************************************************************/
void Update_Proc_All(void)
{
  s16 i,k,l,index;

  //------------------------------һҳ˵------------------------------------//
  for(i=0;i<ABOUT;i++){
    index=PopMenu1_Base[i];
    switch (i){
    case CH1:  
      StateA = PopMenu1_Value[CH1_Enable]? GND : ACT ;  //Ch1ӵػ򼤻״̬ 
      GainA  = PopMenu1_Value[CH1_Vol]%5;               
      KindA  = PopMenu1_Value[CH1_Vol]/5;               //Ch1ѡѹѹ
      CouplA = ((PopMenu1_Value[CH1_Coupl])? DC : AC);  //AC/DCϷʽ
      __Ctrl(AiRANGE, KindA+CouplA+StateA);             //Ch1״̬ˢ
      ParamTab[P1x2]=2*(PopMenu1_Value[CH1_Posi]);      //Ch1αλ 
      ParamTab[W1F]=PopMenu1_Value[CH1_Enable]? B_HID : L_HID;//Ch1 show_hide 
      AiPosi(PopMenu1_Value[CH1_Posi]);                 //Ch1ӲӦλ
      break;
    case CH2:
      StateB = PopMenu1_Value[CH2_Enable]? GND : ACT ;  //Ch2ӵػ򼤻״̬  
      GainB  = PopMenu1_Value[CH2_Vol]%5; 
      KindB  = PopMenu1_Value[CH2_Vol]/5;
      CouplB = ((PopMenu1_Value[CH2_Coupl])? DC : AC);
      __Ctrl(BiRANGE, KindB+CouplB+StateB);
      ParamTab[P2x2]=2*(PopMenu1_Value[CH2_Posi]);
      ParamTab[W2F]=PopMenu1_Value[CH2_Enable]? B_HID : L_HID;
      BiPosi(PopMenu1_Value[CH2_Posi]);
      break;
    case CH3:
      ParamTab[W3F]=PopMenu1_Value[CH3_Enable]? B_HID : L_HID;
      ParamTab[P3x2]=2*(PopMenu1_Value[CH3_Posi]);   
      break;
    case TIMEBASE:
      Set_Base(PopMenu1_Value[TIM_Base]);               // Ӳɨʱλ
      break;
    case TRIGGER:
      k=(PopMenu1_Value[TRI_Ch])?PopMenu1_Value[TRI_Ch2]:PopMenu1_Value[TRI_Ch1];
      l=(PopMenu1_Value[TRI_Ch])?ParamTab[P2x2]:ParamTab[P1x2]; 
      ParamTab[VTx2]=l+2*k;
      ParamTab[VTC]=CH_Col[PopMenu1_Value[TRI_Ch]];
      ParamTab[VTF]=(PopMenu1_Value[TRI_Enable])? L_HID : W_HID;
      break;
    case COURSOR:      
      ParamTab[T1x1]=PopMenu1_Value[CUR_T1]+1;
      ParamTab[T2x1]=PopMenu1_Value[CUR_T2]+1;
      if(PopMenu1_Value[CUR_T]==0)
        ParamTab[T1F]=SHOW;
      else ParamTab[T1F]=L_HID;
      ParamTab[T2F]=ParamTab[T1F];
      ParamTab[V1x2]=2*(PopMenu1_Value[CUR_V1]+1);   
      ParamTab[V2x2]=2*(PopMenu1_Value[CUR_V2]+1);    
      if(PopMenu1_Value[CUR_V]==2)                        // CH1,Ch2,OFF
        ParamTab[V1F]=L_HID;
      else ParamTab[V1F]=SHOW;
      ParamTab[V2F]=ParamTab[V1F];
      if(Cur_PopItem==4)Update[V1F]|=UPD;
      if(Cur_PopItem==5)Update[V2F]|=UPD;
      if(Cur_PopItem==1)Update[T1F]|=UPD;
      if(Cur_PopItem==2)Update[T2F]|=UPD;
      if(Cur_PopItem==6)Update[V1F]|=UPD ;                //V1-V2  
      break;
    case WINDOWS:
      index++;
      switch(PopMenu1_Value[WIN_T0]){
      case 0:
        ParamTab[T0x1]= 125 - PopMenu1_Value[WIN_Posi];
        break;
      case 1:
        ParamTab[T0x1]= Depth/2+125 - PopMenu1_Value[WIN_Posi];
        break;
      case 2:
        ParamTab[T0x1]= Depth-125 - PopMenu1_Value[WIN_Posi];
        break;  
      }
      ParamTab[T0F] =PopMenu1_Value[WIN_Enable];
      if(Status != STOP)ADC_Start();                     //¿ʼADCɨ
      break;
    case WAVE:
      if(PopMenu3_Value[WAVE_Type]==0){         
        __Ctrl(OUT_PSC, FPSC[PopMenu3_Value[WAVE_Freq]]);  
        __Ctrl(OUT_ARR, FARR[PopMenu3_Value[WAVE_Freq]]);  
        __Ctrl(OUT_WTH, FARR[PopMenu3_Value[WAVE_Freq]]*PopMenu3_Value[WAVE_Duty]/10); 
        __Ctrl(OUT_MOD, PULSED); 
      }
      else{                                  
        if(PopMenu3_Value[WAVE_Freq] > MAX_FREQ){  
          PopMenu3_Value[WAVE_Freq] = MAX_FREQ ; 
        }
        __Ctrl(OUT_MOD, DISABLE);
        if(PopMenu3_Value[WAVE_Freq] > 8){
          __Ctrl(OUT_CNT, 36);
          TIM_DA->PSC = Dac_Psc[PopMenu3_Value[WAVE_Freq]] - 1;
          __Ctrl(DAC_TIM, Dac_Tim[PopMenu3_Value[WAVE_Freq]]);  
          __Ctrl(OUT_BUF, WaveOut_Date(PopMenu3_Value[WAVE_Type]));    
        }
        else{
          __Ctrl(OUT_CNT, 180);       
          TIM_DA->PSC = Dac_Psc[PopMenu3_Value[WAVE_Freq]] - 1;
          __Ctrl(DAC_TIM, Dac_Tim[PopMenu3_Value[WAVE_Freq]]); 
          __Ctrl(OUT_BUF, __Info(22+PopMenu3_Value[WAVE_Type]));    
        } 
        __Ctrl(OUT_MOD, ANALOG);
        PopMenu3_Value[WAVE_Duty] = 5;   
      }
      break;   
    case SYSTEM:
      __Ctrl(BUZZVOL, PopMenu3_Value[SYS_Volume]*10);               
      __Ctrl(B_LIGHT, PopMenu3_Value[SYS_BKLight]*10);             
      PD_Cnt = PopMenu3_Value[SYS_Standy]*Unit;
      AutoPwr_Cnt = PopMenu3_Value[SYS_PowerOff]*Unit;
      break;  
    }
  }
}

/******************************** END OF FILE *********************************/
